package cn.com.sailfish.linghang.common;

/**
 * Author: huangpeilin
 * Create at: 2018-12-12 11:43:08
 * Description:
 *
 * @author huangpeilin
 */
public class ErrorConstants {

    //========================= 全局错误码 =============================

    public static final int SUCCESS = 0x00000000;

    public static final int ERR_BAD_PARAM = 0x00000001;

    public static final int ERR_FORM_PARAMETER_ERROR = 0x00000002;

    public static final int FILE_UPLOAD_FAILED = 0x00000003;

    public static final int BIND_FAILED = 0x00000004;

    /**
     * 验证码到期失效
     */
    public static final int CAPTCHA_CODE_EXPIRES = 0x00000005;

    /**
     * 验证码错误
     */
    public static final int CAPTCHA_CODE_ERROR = 0x00000006;

    /**
     * 转化byte数据错误
     */
    public static final int GET_BYTE_ERROR = 0x00000007;

    /**
     * 不是数字的字符串
     */
    public static final int NUMBER_IS_ERROR = 0x00000008;

    /**
     * 验证码为空
     */
    public static final int CAPTCHA_CODE_IS_NULL = 0x00000009;

    /**
     * referer错误
     */
    public static final int REFERER_IS_ERROR = 0x0000000A;

    public static final int ERR_INTERNAL_EXCEPTION = 0xfffffffE;

    public static final int ERR_UNKNOWN = 0xffffffff;


    //========================= 模块错误码 ===============================
    //                   模块定义从0x00010000开始
    /**
     * 用户模块
     */
    private static final int USER_BASE_ERROR_SEGMENT = 0x00010000;
    /**
     * 文件模块
     */
    private static final int FILE_BASE_ERROR_SEGMENT = 0x00020000;

    /**
     * 区域模块
     */
    private static final int AREA_BASE_ERROR_SEGMENT = 0x00030000;

    /**
     * 机型模块
     */
    private static final int MODEL_BASE_ERROR_SEGMENT = 0x00040000;

    /**
     * 发动机模块
     */
    private static final int ENGINE_BASE_ERROR_SEGMENT = 0x00050000;

    /**
     * 课程模块
     */
    private static final int COURSE_BASE_ERROR_SEGMENT = 0x00060000;

    /**
     * 试卷模块
     */
    private static final int QUESTION_PAPER_BASE_ERROR_SEGMENT = 0x00070000;

    /**
     * 考试模块
     */
    private static final int EXAM_BASE_ERROR_SEGMENT = 0x00080000;

    /**
     * 成绩单模块
     */
    private static final int REPORT_CARD_BASE_ERROR_SEGMENT = 0x00090000;
    /**
     * 部门模块
     */
    private static final int ORG_UNIT_BASE_ERROR_SEGMENT = 0x00001000;
    //==========================用户模块==============================

    /**
     * 用户卡号为空
     */
    public static final int USER_CARD_IS_NULL = USER_BASE_ERROR_SEGMENT | 1;

    /**
     * 用户类型为空
     */
    public static final int USER_TYPE_IS_NULL = USER_BASE_ERROR_SEGMENT | 2;

    /**
     * 用户手机号码为空
     */
    public static final int MOBILE_PHONE_IS_NULL = USER_BASE_ERROR_SEGMENT | 3;

    /**
     * 手机号码的格式错误
     */
    public static final int MOBILE_PHONE_IS_ERROR_FORMAT = USER_BASE_ERROR_SEGMENT | 4;

    /**
     * 用户电子邮箱为空
     */
    public static final int EMAIL_IS_NULL = USER_BASE_ERROR_SEGMENT | 5;

    /**
     * 电子邮箱的格式错误
     */
    public static final int EMAIL_IS_ERROR_FORMAT = USER_BASE_ERROR_SEGMENT | 6;

    /**
     * 用户名为空
     */
    public static final int USERNAME_IS_NULL = USER_BASE_ERROR_SEGMENT | 7;

    /**
     * 已经存在使用该手机号码的用户
     */
    public static final int USER_MOBILE_PHONE_IS_ALREADY_EXISTS = USER_BASE_ERROR_SEGMENT | 8;

    /**
     * 已经存在使用该电子邮箱的用户
     */
    public static final int USER_EMAIL_IS_ALREADY_EXISTS = USER_BASE_ERROR_SEGMENT | 9;

    /**
     * 用户类型出错
     */
    public static final int USER_TYPE_IS_ERROR = USER_BASE_ERROR_SEGMENT | 10;

    /**
     * 用户登录账号为空
     */
    public static final int USER_LOGIN_ACCOUNT_IS_NULL = USER_BASE_ERROR_SEGMENT | 11;

    /**
     * 用户密码为空
     */
    public static final int USER_PASSWORD_IS_NULL = USER_BASE_ERROR_SEGMENT | 12;

    /**
     * 用户不存在
     */
    public static final int USER_IS_NOT_EXISTS = USER_BASE_ERROR_SEGMENT | 13;

    /**
     * 用户账号没有被激活，在回收站中
     */
    public static final int USER_IS_NOT_ACTIVATED = USER_BASE_ERROR_SEGMENT | 14;

    /**
     * 登录用户不是管理员或者教员
     */
    public static final int CAN_NOT_OPERATE_WITHOUT_ADMIN_OR_TEACHER = USER_BASE_ERROR_SEGMENT | 15;

    /**
     * 密码错误authority is error.
     */
    public static final int USER_PASSWORD_IS_ERROR = USER_BASE_ERROR_SEGMENT | 16;

    /**
     * 用户权限值出错
     */
    public static final int USER_AUTHORITY_IS_ERROR = USER_BASE_ERROR_SEGMENT | 17;

    /**
     * 用户已经存在
     */
    public static final int USER_IS_ALREADY_EXISTS = USER_BASE_ERROR_SEGMENT | 18;

    /**
     * 用户在考试队列中
     */
    public static final int USER_IS_IN_TEST_QUEUE = USER_BASE_ERROR_SEGMENT | 19;

    /**
     * 用户权限不足
     */
    public static final int INSUFFICIENT_USER_PERMISSION = USER_BASE_ERROR_SEGMENT | 20;

    /**
     * 用户跨区操作
     */
    public static final int USER_OPERATE_ACROSS_REGION = USER_BASE_ERROR_SEGMENT | 21;

    /**
     * 用户ID为空
     */
    public static final int USER_ID_IS_NULL = USER_BASE_ERROR_SEGMENT | 22;

    /**
     * 用户登录的队列名为空
     */
    public static final int USER_QUEUE_NAME_IS_NULL = USER_BASE_ERROR_SEGMENT | 23;

    /**
     * 用户在异地登录
     */
    public static final int USER_REMOTE_LOGIN = USER_BASE_ERROR_SEGMENT | 24;

    /**
     * 请求sso系统失败
     */
    public static final int REQUEST_SSO_SERVER_FAILED = USER_BASE_ERROR_SEGMENT | 25;

    /**
     * 这个权限的用户只能存在一个
     */
    public static final int THIS_USER_PRIVILEGE_ONLY_ONE_CAN_EXIST = USER_BASE_ERROR_SEGMENT | 26;

    /**
     * 用户权限不足
     */
    public static final int USER_PERMISSION_DENIED = USER_BASE_ERROR_SEGMENT | 27;

    /**
     * sso系统不存在该数据失败
     */
    public static final int SSO_SERVER_CAN_NOT_FIND_THIS_DATA = USER_BASE_ERROR_SEGMENT | 28;

    /**
     * 用户账号被锁定
     */
    public static final int USER_ACCOUNT_IS_LOCK = USER_BASE_ERROR_SEGMENT | 29;

    /**
     * 用户名或密码错误，认证失败
     */
    public static final int USER_ACCOUNT_IS_ERROR = USER_BASE_ERROR_SEGMENT | 30;
    /**
     * 触发双因子验证
     */
    public static final int USER_ACCOUNT_IS_VERIFY = USER_BASE_ERROR_SEGMENT | 31;
    /**
     * IP列入黑名单
     */
    public static final int USER_SEND_MESSAGE_IPERROR = USER_BASE_ERROR_SEGMENT | 32;
    /**
     * token信息不存在或者已过期不合法等
     */
    public static final int USER_SEND_MESSAGE_TOKENERROR = USER_BASE_ERROR_SEGMENT | 33;
    /**
     * 双因子认证已关闭，请求失败
     */
    public static final int USER_SEND_MESSAGE_DFACTORERROR = USER_BASE_ERROR_SEGMENT | 34;
    /**
     * 发送验证码失败
     */
    public static final int USER_SEND_MESSAGE_FAILURE = USER_BASE_ERROR_SEGMENT | 35;

    //==========================文件模块==============================

    /**
     * 导入的信息文件不是excel文件
     */
    public static final int FILE_IS_NOT_THE_EXCEL = FILE_BASE_ERROR_SEGMENT | 1;

    /**
     * 导入文件信息失败
     */
    public static final int IMPORT_INFO_IS_FAIL = FILE_BASE_ERROR_SEGMENT | 2;

    /**
     *  文件操作异常
     */
    public static final int FILE_OPERATING_EXCEPTION = FILE_BASE_ERROR_SEGMENT | 3;

    /**
     *  文件不存在
     */
    public static final int  FILE_IS_NOT_EXISTS = USER_BASE_ERROR_SEGMENT | 4;

    /**
     *  文件不是图片
     */
    public static final int  FILE_IS_NOT_IMAGE = USER_BASE_ERROR_SEGMENT | 5;

    /**
     *  图片太大
     */
    public static final int  FILE_IS_TOO_BIG = USER_BASE_ERROR_SEGMENT | 6;

    //==========================区域模块==============================

    /**
     * 区域名字为空
     */
    public static final int AREA_NAME_IS_NULL = AREA_BASE_ERROR_SEGMENT | 1;
    /**
     * 区域已经存在
     */
    public static final int AREA_IS_ALREADY_EXISTS = AREA_BASE_ERROR_SEGMENT | 2;
    /**
     * 区域不存在
     */
    public static final int AREA_IS_NOT_EXISTS = AREA_BASE_ERROR_SEGMENT | 3;
    /**
     * 区域ID为空
     */
    public static final int AREA_ID_IS_NULL = AREA_BASE_ERROR_SEGMENT | 4;

    //==========================机型模块==============================

    /**
     * 机型名字为空
     */
    public static final int MODEL_NAME_IS_NULL = MODEL_BASE_ERROR_SEGMENT | 1;
    /**
     * 机型已经存在
     */
    public static final int MODEL_IS_ALREADY_EXISTS = MODEL_BASE_ERROR_SEGMENT | 2;
    /**
     * 机型不存在
     */
    public static final int MODEL_IS_NOT_EXISTS = MODEL_BASE_ERROR_SEGMENT | 3;
    /**
     * 机型ID为空
     */
    public static final int MODEL_ID_IS_NULL = MODEL_BASE_ERROR_SEGMENT | 4;

    //==========================发动机模块==============================

    /**
     * 发动机名字为空
     */
    public static final int ENGINE_NAME_IS_NULL = ENGINE_BASE_ERROR_SEGMENT | 1;
    /**
     * 发动机已经存在
     */
    public static final int ENGINE_IS_ALREADY_EXISTS = ENGINE_BASE_ERROR_SEGMENT | 2;
    /**
     * 发动机不存在
     */
    public static final int ENGINE_IS_NOT_EXISTS = ENGINE_BASE_ERROR_SEGMENT | 3;
    /**
     * 发动机ID为空
     */
    public static final int ENGINE_ID_IS_NULL = ENGINE_BASE_ERROR_SEGMENT | 4;

    //==========================课程模块==============================
    /**
     * 课程已经存在
     */
    public static final int COURSE_IS_ALREADY_EXISTS = COURSE_BASE_ERROR_SEGMENT | 1;
    /**
     * 课程不存在
     */
    public static final int COURSE_IS_NOT_EXISTS = COURSE_BASE_ERROR_SEGMENT | 2;
    /**
     * 课程ID为空
     */
    public static final int COURSE_ID_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 3;
    /**
     * 检查项ID为空
     */
    public static final int ITEM_ID_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 4;
    /**
     * 检查项名字为空
     */
    public static final int ITEM_NAME_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 5;
    /**
     * 检查项中文名字为空
     */
    public static final int ITEM_CHINESE_NAME_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 6;
    /**
     * 检查项区域名字为空
     */
    public static final int ITEM_REGION_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 7;
    /**
     * 检查项机型为空
     */
    public static final int ITEM_MODEL_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 8;
    /**
     * 检查项发动机为空
     */
    public static final int ITEM_ENGINE_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 9;
    /**
     * 课程名字为空
     */
    public static final int COURSE_NAME_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 10;
    /**
     * 课程中文名字为空
     */
    public static final int COURSE_CHINESE_NAME_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 11;
    /**
     * 课程机型为空
     */
    public static final int COURSE_MODEL_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 12;
    /**
     * 课程发动机为空
     */
    public static final int COURSE_ENGINE_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 13;
    /**
     * 课程职位为空
     */
    public static final int COURSE_DIVISION_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 14;
    /**
     * 导入表中飞机制造商项为空
     */
    public static final int AIR_FRAMER_IS_NULL = COURSE_BASE_ERROR_SEGMENT | 15;
    /**
     * 导入表中职位数值错误
     */
    public static final int DIVISION_IS_ERROR = COURSE_BASE_ERROR_SEGMENT | 16;


    //==========================试卷模块==============================
    /**
     * 试卷已经存在
     */
    public static final int QUESTION_PAPER_IS_ALREADY_EXISTS = QUESTION_PAPER_BASE_ERROR_SEGMENT | 1;
    /**
     * 试卷不存在
     */
    public static final int QUESTION_PAPER_IS_NOT_EXISTS = QUESTION_PAPER_BASE_ERROR_SEGMENT | 2;
    /**
     * 试卷标题为空
     */
    public static final int QUESTION_PAPER_TITLE_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 3;
    /**
     * 试卷考试时长为空
     */
    public static final int QUESTION_PAPER_TEST_LENGTH_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 4;
    /**
     * 试卷人为设定异常数量为空
     */
    public static final int QUESTION_PAPER_RANDOM_ABNORMAL_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 5;
    /**
     * 试卷异常生成类型错误
     */
    public static final int QUESTION_PAPER_EXCEPTION_GENERATE_TYPE_IS_ERROR = QUESTION_PAPER_BASE_ERROR_SEGMENT | 6;
    /**
     * 试卷删除失败
     */
    public static final int QUESTION_PAPER_DELETE_FAILED = QUESTION_PAPER_BASE_ERROR_SEGMENT | 7;
    /**
     * 试卷ID为空
     */
    public static final int QUESTION_PAPER_ID_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 8;
    /**
     * 试卷名字为空
     */
    public static final int QUESTION_PAPER_NAME_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 9;
    /**
     * 试卷描述为空
     */
    public static final int QUESTION_PAPER_DESC_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 10;
    /**
     * 试卷类型为空
     */
    public static final int QUESTION_PAPER_TYPE_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 11;
    /**
     * 试卷类型错误
     */
    public static final int QUESTION_PAPER_TYPE_IS_ERROR = QUESTION_PAPER_BASE_ERROR_SEGMENT | 12;
    /**
     * 试卷的课程ID为空
     */
    public static final int QUESTION_PAPER_COURSE_ID_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 13;
    /**
     * 试卷异常生成类型为空
     */
    public static final int QUESTION_PAPER_ABNORMAL_GENERATE_TYPE_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 14;
    /**
     * 试卷总分数为空
     */
    public static final int QUESTION_PAPER_SCORE_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 15;
    /**
     * 试卷通过分数为空
     */
    public static final int QUESTION_PAPER_PASSING_SCORE_IS_NULL = QUESTION_PAPER_BASE_ERROR_SEGMENT | 15;


    //==========================考试模块==============================


    /**
     * 考试监考老师的数量错误
     */
    public static final int INVIGILATOR_NUMBER_IS_ERROR = EXAM_BASE_ERROR_SEGMENT | 1;
    /**
     * 用户正在考试，指定考试失败
     */
    public static final int USER_SPECIFIED_TEST_FAILED = EXAM_BASE_ERROR_SEGMENT | 2;
    /**
     * 考试ID为空
     */
    public static final int EXAM_ID_IS_NULL = EXAM_BASE_ERROR_SEGMENT | 3;
    /**
     * 考试不存在
     */
    public static final int EXAM_IS_NOT_EXISTS = EXAM_BASE_ERROR_SEGMENT | 4;


    //==========================成绩单模块==============================

    /**
     * 成绩单不存在
     */
    public static final int REPORT_CARD_IS_NOT_EXISTS = REPORT_CARD_BASE_ERROR_SEGMENT | 1;
    /**
     * 成绩单ID为空
     */
    public static final int REPORT_CARD_ID_IS_NULL = REPORT_CARD_BASE_ERROR_SEGMENT | 2;
    /**
     * 成绩单的评定为空
     */
    public static final int REPORT_CARD_ASSESSMENT_IS_NULL = REPORT_CARD_BASE_ERROR_SEGMENT | 3;
    /**
     * 成绩单的分数为空
     */
    public static final int REPORT_CARD_SCORE_IS_NULL = REPORT_CARD_BASE_ERROR_SEGMENT | 4;
    /**
     * 成绩单的评定错误
     */
    public static final int REPORT_CARD_ASSESSMENT_IS_ERROR = REPORT_CARD_BASE_ERROR_SEGMENT | 5;

    //==========================部门模块==============================

    /**
     * 部门编码为空
     */
    public static final int ORG_UNIT_LEVEL_IS_NULL = ORG_UNIT_BASE_ERROR_SEGMENT | 1;

}
