package cn.com.sailfish.linghang.common;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import static cn.com.sailfish.linghang.common.ErrorConstants.*;

/**
 * Author: huangpeilin
 * Create at: 2018-12-12 11:44:18
 * Description:
 *
 * @author huangpeilin
 */
public class ErrorMessages {

    // 默认错误描述
    public static final String DEFAULT_ERROR_MESSAGE = "unknown error";

    private static final Map<Integer, String> MESSAGES;

    static {
        Map<Integer, String> map = new HashMap<Integer, String>();
        map.put(ERR_BAD_PARAM, "bad request param");
        map.put(ERR_FORM_PARAMETER_ERROR, "form parameter error");
        map.put(FILE_UPLOAD_FAILED, "file upload failed.");
        map.put(BIND_FAILED, "bind failed.");
        map.put(CAPTCHA_CODE_EXPIRES, "The Captcha verification code expires.");
        map.put(CAPTCHA_CODE_ERROR, "The Captcha verification code error.");
        map.put(GET_BYTE_ERROR, "Error converting byte data.");
        map.put(NUMBER_IS_ERROR, "Strings that are not Numbers");
        map.put(CAPTCHA_CODE_IS_NULL, "The Captcha verification code is null.");
        map.put(REFERER_IS_ERROR, "referer is error!");
        map.put(ERR_INTERNAL_EXCEPTION, "internal server exception");

        // 添加更多的错误的描述
        MESSAGES = Collections.unmodifiableMap(map);

        // 用户模块
        map.put(USER_CARD_IS_NULL, "user card is null.");
        map.put(USER_TYPE_IS_NULL, "user type is null.");
        map.put(MOBILE_PHONE_IS_NULL, "mobile phone is null.");
        map.put(MOBILE_PHONE_IS_ERROR_FORMAT, "mobile phone is error format.");
        map.put(EMAIL_IS_NULL, "email is null.");
        map.put(EMAIL_IS_ERROR_FORMAT, "email is error format.");
        map.put(USERNAME_IS_NULL, "username is null.");
        map.put(USER_MOBILE_PHONE_IS_ALREADY_EXISTS, "mobile phone is already exists.");
        map.put(USER_EMAIL_IS_ALREADY_EXISTS, "email is already exists.");
        map.put(USER_TYPE_IS_ERROR, "user type is error");
        map.put(USER_LOGIN_ACCOUNT_IS_NULL, "user login account is null.");
        map.put(USER_PASSWORD_IS_NULL, "user password is null.");
        map.put(USER_IS_NOT_EXISTS, "user is not exists.");
        map.put(USER_IS_NOT_ACTIVATED, "user is not activated.");
        map.put(CAN_NOT_OPERATE_WITHOUT_ADMIN_OR_TEACHER, "user is not a admin or teacher.");
        map.put(USER_PASSWORD_IS_ERROR, "user password is error.");
        map.put(USER_AUTHORITY_IS_ERROR, "authority is error.");
        map.put(USER_IS_ALREADY_EXISTS, "user is already exists.");
        map.put(USER_IS_IN_TEST_QUEUE, "user is in test queue.");
        map.put(INSUFFICIENT_USER_PERMISSION, "insufficient user permissions.");
        map.put(USER_OPERATE_ACROSS_REGION, "users operate across regions.");
        map.put(USER_ID_IS_NULL, "user id is null.");
        map.put(USER_QUEUE_NAME_IS_NULL, "user queue name is null.");
        map.put(USER_REMOTE_LOGIN, "user remote login.");
        map.put(REQUEST_SSO_SERVER_FAILED, "request sso server failed");
        map.put(THIS_USER_PRIVILEGE_ONLY_ONE_CAN_EXIST, "Only one user with this privilege can exist.");
        map.put(USER_PERMISSION_DENIED, "permission denied.");
        map.put(SSO_SERVER_CAN_NOT_FIND_THIS_DATA, "can not find this data.");
        map.put(USER_ACCOUNT_IS_LOCK, "user account is lock.");
        map.put(USER_ACCOUNT_IS_ERROR, "user account is error.");
        map.put(USER_ACCOUNT_IS_VERIFY, "user account is verify.");
        map.put(USER_SEND_MESSAGE_IPERROR, "user send message iperror.");
        map.put(USER_SEND_MESSAGE_TOKENERROR, "user send message tokenerror.");
        map.put(USER_SEND_MESSAGE_DFACTORERROR, "user send message dfactorerror.");
        map.put(USER_SEND_MESSAGE_FAILURE, "user send message failure.");

        // 文件模块
        map.put(FILE_IS_NOT_THE_EXCEL, "File is not the excel.");
        map.put(IMPORT_INFO_IS_FAIL, "Import info is fail.");
        map.put(FILE_OPERATING_EXCEPTION, "File operating exception.");
        map.put(FILE_IS_NOT_EXISTS, "File is not exists.");
        map.put(FILE_IS_NOT_IMAGE, "File is not image.");
        map.put(FILE_IS_TOO_BIG, "file is too big.");

        // 区域模块
        map.put(AREA_NAME_IS_NULL, "area name is null.");
        map.put(AREA_IS_ALREADY_EXISTS, "area is already exists.");
        map.put(AREA_IS_NOT_EXISTS, "area is not exists.");
        map.put(AREA_ID_IS_NULL, "area id is null.");

        // 机型模块
        map.put(MODEL_NAME_IS_NULL, "model name is null.");
        map.put(MODEL_IS_ALREADY_EXISTS, "model is already exists.");
        map.put(MODEL_IS_NOT_EXISTS, "model is not exists.");
        map.put(MODEL_ID_IS_NULL, "model id is null.");

        // 发动机模块
        map.put(ENGINE_NAME_IS_NULL, "engine name is null.");
        map.put(ENGINE_IS_ALREADY_EXISTS, "engine is already exists.");
        map.put(ENGINE_IS_NOT_EXISTS, "engine is not exists.");
        map.put(ENGINE_ID_IS_NULL, "engine id is null.");

        // 课程模块
        map.put(COURSE_IS_ALREADY_EXISTS, "course is already exists.");
        map.put(COURSE_IS_NOT_EXISTS, "course is not exists.");
        map.put(COURSE_ID_IS_NULL, "course id is null.");
        map.put(ITEM_ID_IS_NULL, "item id is null.");
        map.put(ITEM_NAME_IS_NULL, "item name is null.");
        map.put(ITEM_CHINESE_NAME_IS_NULL, "item chinese name is null.");
        map.put(ITEM_REGION_IS_NULL, "item region is null.");
        map.put(ITEM_MODEL_IS_NULL, "item model is null.");
        map.put(ITEM_ENGINE_IS_NULL, "item engine is null.");
        map.put(COURSE_NAME_IS_NULL, "course name is null.");
        map.put(COURSE_CHINESE_NAME_IS_NULL, "course chinese name is null.");
        map.put(COURSE_MODEL_IS_NULL, "course model is null.");
        map.put(COURSE_ENGINE_IS_NULL, "course engine is null.");
        map.put(COURSE_DIVISION_IS_NULL, "course division is null.");
        map.put(AIR_FRAMER_IS_NULL, "air framer is null.");
        map.put(DIVISION_IS_ERROR, "division is error.");

        // 试卷模块
        map.put(QUESTION_PAPER_IS_ALREADY_EXISTS, "question paper is already exists.");
        map.put(QUESTION_PAPER_IS_NOT_EXISTS, "question paper is not exists.");
        map.put(QUESTION_PAPER_TITLE_IS_NULL, "question paper id is null.");
        map.put(QUESTION_PAPER_TEST_LENGTH_IS_NULL, "question paper test length is null.");
        map.put(QUESTION_PAPER_RANDOM_ABNORMAL_IS_NULL, "question paper random abnormal is null");
        map.put(QUESTION_PAPER_EXCEPTION_GENERATE_TYPE_IS_ERROR, "question paper exception generate type is error.");
        map.put(QUESTION_PAPER_DELETE_FAILED, "The paper is used and cannot be deleted.");
        map.put(QUESTION_PAPER_ID_IS_NULL, "question paper id is null.");
        map.put(QUESTION_PAPER_NAME_IS_NULL, "question paper name is null");
        map.put(QUESTION_PAPER_DESC_IS_NULL, "question paper desc is null.");
        map.put(QUESTION_PAPER_TYPE_IS_NULL, "question paper type is null.");
        map.put(QUESTION_PAPER_TYPE_IS_ERROR, "question paper type is error.");
        map.put(QUESTION_PAPER_COURSE_ID_IS_NULL, "question paper course id is null.");
        map.put(QUESTION_PAPER_ABNORMAL_GENERATE_TYPE_IS_NULL, "question paper abnormal generate type is null.");
        map.put(QUESTION_PAPER_SCORE_IS_NULL, "question paper score is null.");
        map.put(QUESTION_PAPER_PASSING_SCORE_IS_NULL, "question paper passing score is null.");

        // 考试模块
        map.put(INVIGILATOR_NUMBER_IS_ERROR, "invigilator number is error.");
        map.put(USER_SPECIFIED_TEST_FAILED, "The specified user failed the test");
        map.put(EXAM_ID_IS_NULL, "exam id is null");
        map.put(EXAM_IS_NOT_EXISTS, "exam is not exists.");

        // 成绩单模块
        map.put(REPORT_CARD_IS_NOT_EXISTS, "report card is not exists.");
        map.put(REPORT_CARD_ID_IS_NULL, "report card id is null.");
        map.put(REPORT_CARD_ASSESSMENT_IS_NULL, "report card assessment is null.");
        map.put(REPORT_CARD_SCORE_IS_NULL, "report card score is null.");
        map.put(REPORT_CARD_ASSESSMENT_IS_ERROR, "report card assessment is error.");

        //部门模块
        map.put(ORG_UNIT_LEVEL_IS_NULL, "orgUnitLevel is null.");
    }

    /**
     * 通过error code取得错误描述
     *
     * @param errCode : int 类型的错误代码
     * @return String : 返回错误描述
     */
    public static String getErrorMessage(int errCode) {
        return MESSAGES.get(errCode);
    }
}
