package cn.com.sailfish.linghang.common;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * Author: huangpeilin
 * Create at: 2018-12-12 11:42:32
 * Description:
 *
 * @author huangpeilin
 */
@ApiModel("统一返回Dto")
@NoArgsConstructor
@AllArgsConstructor
@Data
@Accessors(chain = true)
public class RestRespDTO<T> implements Serializable {

    @ApiModelProperty("响应码")
    private Integer errorCode = ErrorConstants.SUCCESS;

    @ApiModelProperty("描述")
    private String errorMessage;

    @ApiModelProperty("数据")
    private T data;

    public RestRespDTO success() {
        return new RestRespDTO(ErrorConstants.SUCCESS, "Success", null);
    }

    public RestRespDTO success(T data) {
        return new RestRespDTO(ErrorConstants.SUCCESS, "Success", data);
    }

}
