package cn.com.sailfish.linghang.config;

import cn.com.sailfish.linghang.config.property.FileUploadProperty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.servlet.MultipartConfigFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.util.unit.DataSize;

import javax.servlet.MultipartConfigElement;
import java.io.File;

/**
 * Author: huangpeilin
 * Create at: 2019-04-22 11:03:35
 * Description:
 *
 * @author huangpeilin
 */
@Configuration
public class FileUploadConfig {

    @Autowired
    private FileUploadProperty fileUploadProperty;

    /**
     *  文件上传配置
     * @return
     */
    @Bean
    public MultipartConfigElement multipartConfigElement() {
        MultipartConfigFactory factory = new MultipartConfigFactory();
        // 单个文件最大
        factory.setMaxFileSize(DataSize.parse(fileUploadProperty.getMaxFileSize()));
        // 设置总上传数据总大小
        factory.setMaxRequestSize(DataSize.parse(fileUploadProperty.getMaxRequestSize()));
        // 文件上传的临时路径
        String location = System.getProperty("user.dir") + "/tmp";
        File tmpFile = new File(location);
        if (!tmpFile.exists()) {
            tmpFile.mkdirs();
        }
        factory.setLocation(location);
        return factory.createMultipartConfig();
    }
}
