package cn.com.sailfish.linghang.config;

import cn.com.sailfish.linghang.config.property.*;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.converter.StringHttpMessageConverter;
import org.springframework.web.client.RestTemplate;

import java.nio.charset.Charset;

/**
 * Author: huangpeilin
 * Create at: 2019-04-22 11:03:35
 * Description:
 *
 * @author huangpeilin
 */
@Configuration
@EnableConfigurationProperties({
        FileUploadProperty.class,
        SecurityProperty.class,
        ExportTemplateProperty.class,
        SsoProperty.class,
        CaptchaProperty.class
})
public class SailfishPropertiesConfig {

    // 设置RestTemplate的超时时间
    @Bean
    public RestTemplate restTemplate() {
        RestTemplate restTemplate = new RestTemplate();
        restTemplate.getMessageConverters()
                .add(0, new StringHttpMessageConverter(Charset.forName("UTF-8")));

        return restTemplate;
    }

}
