package cn.com.sailfish.linghang.controller.admin;

import cn.com.sailfish.linghang.common.RestRespDTO;
import cn.com.sailfish.linghang.domain.BannerControl;
import cn.com.sailfish.linghang.service.admin.BannerControlAdminService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@Api(description = "[管理后台]WEB banner页操作管理")
@RestController
@RequestMapping("/admin/bannerControl")
public class BannerControlController {

    @Autowired
    private BannerControlAdminService bannerControlAdminService;

    @ApiOperation("更改banner回显间隔")
    @GetMapping("/ChangeSpace")
    public RestRespDTO ChangeSpace(@ApiParam("变更的值") @RequestParam("value") String value) {
        bannerControlAdminService.ChangeSpace(value);
        return new RestRespDTO().success();
    }

    @ApiOperation("更改banner回显方向")

    @PostMapping("/move")
    public RestRespDTO moveDirection() {
        bannerControlAdminService.moveDirection();
        return new RestRespDTO().success();
    }

    @ApiOperation("查询bannerControl")
    @PostMapping("/searchBannerControl")
    public RestRespDTO searchBannerControl() {
        List<BannerControl> _bannerControl = bannerControlAdminService.searchBannerControl();
        return new RestRespDTO().success(_bannerControl);
    }

}
