package cn.com.sailfish.linghang.controller.admin;


import cn.com.sailfish.linghang.common.RestRespDTO;
import cn.com.sailfish.linghang.domain.OperateDto.NewsPaperOperateDto;
import cn.com.sailfish.linghang.service.crawler.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@Api(description = "[管理后台]网页爬虫" +
        "")
@RestController
@RequestMapping("/admin/crawler")
public class CrawlerController {

    @ApiOperation(value = "爬虫抓取数据")
    @PostMapping("/grab")
    public RestRespDTO grab(@ApiParam("url") @RequestParam("url") String url) {
        Integer type = 0;
        if(url.contains("news.carnoc.com")){
            CrawlerService crawlerService = new CarnocService();
            return new RestRespDTO().success(crawlerService.crawler(url));
        }
        else if(url.contains("www.caac.gov.cn")){
            CrawlerService crawlerService = new CaacgovService();
            return new RestRespDTO().success(crawlerService.crawler(url));
        }
        else if(url.contains("www.cata.org.cn")){
            CrawlerService crawlerService = new CataorgService();
            return new RestRespDTO().success(crawlerService.crawler(url));
        }
        else if(url.contains("caacnews.com.cn")){
            CrawlerService crawlerService = new CaacnewsService();
            return new RestRespDTO().success(crawlerService.crawler(url));
        }else {
            RestRespDTO restRespDTO = new RestRespDTO();
            restRespDTO.setErrorCode(436);
            restRespDTO.setErrorMessage("网址非法");
            return restRespDTO;
        }
    }

}
