package cn.com.sailfish.linghang.controller.admin;

import cn.com.sailfish.linghang.common.RestRespDTO;
import cn.com.sailfish.linghang.dao.web.response.PageResponse;
import cn.com.sailfish.linghang.domain.User;
import cn.com.sailfish.linghang.service.admin.RBACAdminService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Api(description = "[管理后台]权限管理")
@RestController
@RequestMapping("/admin/RBAC")
public class RBACController {
    @Autowired
    private RBACAdminService rbacAdminService;

    @ApiOperation("分页查询")
    @PostMapping()
    public RestRespDTO courseIntroducePage(@ApiParam("当前页") @RequestParam Integer page,
                                           @ApiParam("每一页的条数  默认是5") @RequestParam Integer pageSize,
                                           @ApiParam("关键字查询") @RequestParam(required = false) String crux) {
        if (page < 1) {
            page = 1;
        }
        if (pageSize < 1) {
            pageSize = 5;
        }



        PageResponse<User> userPageResponse = rbacAdminService.findAllByStatue(page, pageSize,crux);
        return new RestRespDTO().success(userPageResponse);
    }

    @ApiOperation("根据id和前后端参数更改权限")
    @GetMapping("/{id:\\d+}/ChangeRBAC")
    public RestRespDTO ChangeRBAC(@ApiParam("主键Id") @PathVariable String id,
                                  @ApiParam("前后端分类 0代表前端 1代表后端") @RequestParam String type) {
        rbacAdminService.ChangeRBAC(id,type);
        return new RestRespDTO().success();
    }

    @ApiOperation("根据id修改状态")
    @GetMapping("/{id:\\d+}/ChangeActivation")
    public RestRespDTO ChangeActivation(@ApiParam("主键Id") @PathVariable String id) {
        rbacAdminService.ChangeActivation(id);
        return new RestRespDTO().success();
    }

    @ApiOperation("根据id查询权限")
    @GetMapping("/{id:\\d+}/RABCfindbyid")
    public RestRespDTO RABCfindbyid(@ApiParam("主键Id") @PathVariable String id) {
        String authorityTemplate = rbacAdminService.RABCfindbyid(id);
        return new RestRespDTO().success(authorityTemplate);
    }

}
