package cn.com.sailfish.linghang.domain;

import cn.com.sailfish.linghang.common.auditor.Auditable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.*;
import java.io.Serializable;

@Data
@Entity
@ApiModel(value = "banner首页")
@Table(name="banner_details")
public class BannerDetails extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @ApiModelProperty(value = "主键自增")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name="id")
    private Long id;

    @ApiModelProperty(value = "banner标题")
    @Column(name="banner_title")
    private String bannerTitle;

    @ApiModelProperty(value = "banner简介")
    @Column(name="banner_content")
    private String bannerContent;

    @ApiModelProperty(value = "banner地址,开发后期改为bannerID")
    @Column(name="image_url")
    private String imageUrl;

    @ApiModelProperty(value = "暂停使用,备用字段")
    @Column(name="banner_url")
    private String bannerUrl;

    @ApiModelProperty(value="是否发布")
    @Column(name="release_statue")
    private Integer releaseStatue;

    @ApiModelProperty(value="序列")
    @Column(name="seqencing")
    private Integer seqencing;

    @ApiModelProperty(value = "是否有效")
    @Column(name="is_del")
    private Integer isDel;

    @ApiModelProperty(value = "banner是否启用")
    @Column(name="banner_on")
    private Integer bannerOn;


}
