package cn.com.sailfish.linghang.domain;

import cn.com.sailfish.linghang.common.auditor.Auditable;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.*;
import java.io.Serializable;

@Data
@Entity
@Table(name="course_introduce")
public class CourseIntroduce extends Auditable implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @ApiModelProperty(value = "主键自增")
    @Column(name="id")
    private Long id;

    @ApiModelProperty(value = "课程标题")
    @Column(name="courseTitle")
    private String courseTitle;

    @ApiModelProperty(value = "图片id，暂作为图片地址")
    @Column(name="image_url")
    private String imageUrl;

    @ApiModelProperty(value = "0：未发布 1：发布")
    @Column(name="release_statue")
    private Integer releaseStatue;

    @ApiModelProperty(value = "0：失效 1：有效")
    @Column(name="is_del")
    private Integer isDel;

    @ApiModelProperty(value="内容")
    @Column(name="content")
    private String content;

    @ApiModelProperty(value = "序列")
    @Column(name="seqencing")
    private Integer seqencing;

    @ApiModelProperty(value = "course_url")
    @Column(name="course_url")
    private String courseUrl;

    @ApiModelProperty(value = "强推首页")
    @Column(name="push_index")
    private Integer pushIndex;

    @ApiModelProperty(value = "二级列表置顶")
    @Column(name="second_top")
    private Integer secondTop;

    @ApiModelProperty(value = "简介")
    @Column(name="intro")
    private String intro;
}
