package cn.com.sailfish.linghang.domain;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.time.Instant;
import java.util.Objects;
import java.util.List;

import cn.com.sailfish.linghang.common.auditor.Auditable;

/**
 * @author: AutoCoder (maintained by newma<newma@live.cn>)
 * @create: 2019-07-11 11:19:24
 */

/**
 * 发动机信息表
 */
@Entity
@Table(name = "engine")
public class Engine extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "name")
    @Size(min = 1, max = 50)
    private String name; // 发动机名字, 长度大于1小于50, 不为空且唯一

    @Column(name = "type")
    private Integer type; // 发动机和名字对应的值 0:非发动机检查项; 1:V2500; 2:CFM56; 3:PW1100





    // getter and setter

    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getType() {
        return this.type;
    }

    public void setType(Integer type) {
        this.type = type;
    }





    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "{ Engine: { " +
            "'id': '" + getId() + "'" +
            ", 'name': '" + getName() + "'" +
            ", 'type': '" + getType() + "'" +
            " }}";
    }
}
