package cn.com.sailfish.linghang.domain;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.time.Instant;
import java.util.Objects;
import java.util.List;

import cn.com.sailfish.linghang.common.auditor.Auditable;

/**
 * @author: AutoCoder (maintained by newma<newma@live.cn>)
 * @create: 2019-07-11 11:19:25
 */

/**
 * 考试信息表
 */
@Entity
@Table(name = "exam")
public class Exam extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "name")
    private String name; // 考试名字

    @Column(name = "class_type")
    private String classType; // 班别 初训 复训

    @Column(name = "remarks")
    private String remarks; // 考试备注

    @Column(name = "exam_time")
    private Instant examTime; // 考试日期

    @Column(name = "invigilator")
    private String invigilator; // 监考人集合

    @Column(name = "b_is_delete")
    private Boolean biosIsDelete; // 是否已经在回收站中, 默认是false

    @ManyToOne
    @JoinColumn(name = "area_id")
    private Area area;

    @ManyToOne
    @JoinColumn(name = "question_paper_id")
    private QuestionPaper questionPaper;


    // getter and setter

    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getClassType() {
        return this.classType;
    }

    public void setClassType(String classType) {
        this.classType = classType;
    }

    public String getRemarks() {
        return this.remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public Instant getExamTime() {
        return this.examTime;
    }

    public void setExamTime(Instant examTime) {
        this.examTime = examTime;
    }

    public String getInvigilator() {
        return this.invigilator;
    }

    public void setInvigilator(String invigilator) {
        this.invigilator = invigilator;
    }

    public Boolean getBiosIsDelete() {
        return this.biosIsDelete;
    }

    public void setBiosIsDelete(Boolean biosIsDelete) {
        this.biosIsDelete = biosIsDelete;
    }

    public Area getArea() {
        return this.area;
    }

    public void setArea(Area area) {
        this.area = area;
    }

    public QuestionPaper getQuestionPaper() {
        return this.questionPaper;
    }

    public void setQuestionPaper(QuestionPaper questionPaper) {
        this.questionPaper = questionPaper;
    }


    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "{ Exam: { " +
            "'id': '" + getId() + "'" +
            ", 'name': '" + getName() + "'" +
            ", 'classType': '" + getClassType() + "'" +
            ", 'remarks': '" + getRemarks() + "'" +
            ", 'examTime': '" + getExamTime() + "'" +
            ", 'invigilator': '" + getInvigilator() + "'" +
            ", 'biosIsDelete': '" + getBiosIsDelete() + "'" +
            " }}";
    }
}
