package cn.com.sailfish.linghang.domain;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.time.Instant;
import java.util.Objects;
import java.util.List;

import cn.com.sailfish.linghang.common.auditor.Auditable;

/**
 * @author: AutoCoder (maintained by newma<newma@live.cn>)
 * @create: 2019-07-11 11:19:25
 */

/**
 * 异常项表
 */
@Entity
@Table(name = "exception_item")
public class ExceptionItem extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "import_id")
    private Long importId; // 异常项导入表的ID值

    @Column(name = "name")
    private String name; // 异常名字

    @Column(name = "details")
    private String details; // 详情

    @Column(name = "region")
    private String region; // 所属的区域 比如 A区，B区 CD区

    @ManyToMany(mappedBy = "exceptionItem")
    private List<Course> course;

    @ManyToOne
    @JoinColumn(name = "model_id")
    private Model model;

    @ManyToOne
    @JoinColumn(name = "engine_id")
    private Engine engine;

    @ManyToOne
    @JoinColumn(name = "check_item_id")
    private CheckItem checkItem;



    // getter and setter

    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getImportId() {
        return this.importId;
    }

    public void setImportId(Long importId) {
        this.importId = importId;
    }

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDetails() {
        return this.details;
    }

    public void setDetails(String details) {
        this.details = details;
    }

    public String getRegion() {
        return this.region;
    }

    public void setRegion(String region) {
        this.region = region;
    }

    public List<Course> getCourse() {
        return this.course;
    }

    public void setCourse(List<Course> course) {
        this.course = course;
    }

    public Model getModel() {
        return this.model;
    }

    public void setModel(Model model) {
        this.model = model;
    }

    public Engine getEngine() {
        return this.engine;
    }

    public void setEngine(Engine engine) {
        this.engine = engine;
    }

    public CheckItem getCheckItem() {
        return this.checkItem;
    }

    public void setCheckItem(CheckItem checkItem) {
        this.checkItem = checkItem;
    }



    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "{ ExceptionItem: { " +
            "'id': '" + getId() + "'" +
            ", 'importId': '" + getImportId() + "'" +
            ", 'name': '" + getName() + "'" +
            ", 'details': '" + getDetails() + "'" +
            ", 'region': '" + getRegion() + "'" +
            " }}";
    }
}
