package cn.com.sailfish.linghang.domain;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.time.Instant;
import java.util.Objects;
import java.util.List;

import cn.com.sailfish.linghang.common.auditor.Auditable;

/**
 * @author: AutoCoder (maintained by newma<newma@live.cn>)
 * @create: 2019-07-11 11:19:25
 */

/**
 * 文件信息表,表名file_info,如无指定@(主键)则默认创建id字段并设为主键
 */
@Entity
@Table(name = "file_info")
public class FileInfo extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "type")
    private String type; // 文件类型,png,jpg,avi,mp3

    @Column(name = "path")
    private String path; // 文件路径

    @Column(name = "title")
    private String title; // 文件标题

    @Column(name = "size")
    private Long size; // 文件大小

    @Column(name = "key_name", length = 128, nullable = false)
    private String keyName; // 文件的关键key

    // getter and setter

    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getType() {
        return this.type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getPath() {
        return this.path;
    }

    public void setPath(String path) {
        this.path = path;
    }

    public String getTitle() {
        return this.title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Long getSize() {
        return this.size;
    }

    public void setSize(Long size) {
        this.size = size;
    }

    public String getKeyName() {
        return this.keyName;
    }

    public void setKeyName(String keyName) {
        this.keyName = keyName;
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "{ FileInfo: { " +
            "'id': '" + getId() + "'" +
            ", 'type': '" + getType() + "'" +
            ", 'path': '" + getPath() + "'" +
            ", 'title': '" + getTitle() + "'" +
            ", 'size': '" + getSize() + "'" +
            ", 'keyName': '" + getKeyName() + "'" +
            " }}";
    }
}
