package cn.com.sailfish.linghang.domain;

import cn.com.sailfish.linghang.common.auditor.Auditable;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.io.Serializable;

@Data
@Entity
@Table(name="image_details")
public class ImageDetails extends Auditable implements Serializable {

    @Id
    @ApiModelProperty(value = "主键自增")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name="id")
    private Long id;

    @ApiModelProperty(value = "图片名称")
    @Column(name="name")
    private String name;

    @ApiModelProperty(value = "路径")
    @Column(name="path")
    private String path;

    @ApiModelProperty(value = "创建人")
    @Column(name="creater")
    private String creater;

    @ApiModelProperty(value = "图片分类")
    @Column(name="source_type")
    private String sourceType;


    @ApiModelProperty(value = "0：正常 1 删除")
    @Column(name="is_del")
    private Integer isDel;

    @ApiModelProperty(value = "资源类型")
    @Column(name="type")
    private Integer type;

    @ApiModelProperty(value = "文件大小")
    @Column(name="size")
    private Long size;
}
