package cn.com.sailfish.linghang.domain;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.time.Instant;
import java.util.Objects;
import java.util.List;

import cn.com.sailfish.linghang.common.auditor.Auditable;
import lombok.Data;

/**
 * @author: AutoCoder (maintained by newma<newma@live.cn>)
 * @create: 2019-07-11 11:19:25
 */

/**
 * 机型信息表
 */
@Data
@Entity
@Table(name = "model")
public class Model extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "name")
    @Size(min = 1, max = 50)
    private String name; // 机型名字, 长度大于1小于50, 不为空且唯一

    @Column(name = "name_type")
    private Integer nameType; // 机型和名字对应的值 0:A320 1:A380 2:A330 3:B737 4:B777 5:C919

    @Column(name = "brand")
    @Size(min = 1, max = 50)
    private String brand; // 飞机制造商 可以为 空中客车 波音 中国商飞

    @Column(name = "brand_type")
    private Integer brandType; // 飞机制造商和名字对应的值 0:空客; 1:波音; 2:商飞




}
