package cn.com.sailfish.linghang.domain;

import cn.com.sailfish.linghang.common.auditor.Auditable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.*;
import java.io.Serializable;

@Data
@Entity
@ApiModel(value = "新闻对象NewsPaper",description = "新闻咨询")
@Table(name="new_papers")
public class NewsPaper extends Auditable implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @ApiModelProperty(value = "主键ID")
    @Column(name = "id")
    private Long id;

    @ApiModelProperty(value="新闻标题")
    @Column(name="new_title")
    private String newsTitle;

    @ApiModelProperty(value ="图片ID现修改为图片地址")
    @Column(name="image_url")
    private String imageUrl;

    @ApiModelProperty(value = "发布状态")
    @Column(name="release_statue")
    private Integer releaseStatue;

    @ApiModelProperty(value="序列")
    @Column(name="seqencing")
    private Integer seqencing;

    @ApiModelProperty(value="类型 1：新闻咨询 ；2：行业信息")
    @Column(name="classtype")
    private Integer classtype;

    @ApiModelProperty(value = "状态：0：失效，1：有效")
    @Column(name="is_del")
    private Integer isDel;

    @ApiModelProperty(value = "简介")
    @Column(name="intro")
    private String intro;

    @ApiModelProperty(value = "内容")
    @Column(name="content")
    private String content;

    @ApiModelProperty(value = "强推首页")
    @Column(name="push_index")
    private Integer pushIndex;

    @ApiModelProperty(value = "二维码url")
    @Column(name="second_top")
    private Integer secondTop;

    @ApiModelProperty(value = "新闻url")
    @Column(name="new_url")
    private String newUrl;


}
