package cn.com.sailfish.linghang.domain;

import cn.com.sailfish.linghang.common.auditor.Auditable;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @auther lichunjiang
 * @description 部门表；
 * @date 2019/10/15 08/39
 *
 */
@Entity
@Table(name="org_info_form")
public class OrgInfoForm extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;
    //HR部门号
    @Id
    @Column(name="org_unit_id")
    private  String orgUnitID;
    //部门名称
    @Column(name="org_unit_name")
    private String orgUnitName;
    //部门全称
    @Column(name="org_unit_fullname")
    private String orgUnitFullName;
    //机构性质 普通部门、虚拟部门；可空
    @Column(name="org_unit_role")
    private String orgUnitRole;
    //机构级别 一级机构、二级机构、三级机构、四级机构、五级机构、其他；可空
    @Column(name="org_unit_level")
    private String orgUnitLevel;
    //机构类型 总部机关部门、驻场单位、分公司、基地、国内营业部、国外办事处、航空子公司、特设机构、其他控股子公司、联营及参股子公司、合营公司；可空
    @Column(name="org_unit_type")
    private String orgUnitType;
    //业务系统 飞行、客舱、保卫、机关、航务、客运、货运、地服、财务、机务、信息、航服、航食、三产、后保、其他；可空
    @Column(name="org_unit_attribute")
    private String orgUnitAttribute;
    //地区分布 行政区划；可空
    @Column(name="org_unit_geo_zone")
    private String orgUnitGeoZone;
    //HR父部门号
    @Column(name="parent_org_unitid")
    private String parentOrgUnitid;
    //部门/组织标识 部门/组织
    @Column(name="hr_org_dept_flag")
    private String hrOrgDeptFlag;
    //启用状态 1=未启用，2=已启用，3=已停用
    @Column(name="enable_state")
    private String enableState;
    //排序号
    @Column(name="display_order")
    private String displayorder;


    public OrgInfoForm() {
    }

    public OrgInfoForm(String orgUnitID, String orgUnitName, String orgUnitFullName, String orgUnitRole,
                       String orgUnitLevel, String orgUnitType, String orgUnitAttribute, String orgUnitGeoZone, String parentOrgUnitid, String hrOrgDeptFlag, String enableState, String displayorder) {
        this.orgUnitID = orgUnitID;
        this.orgUnitName = orgUnitName;
        this.orgUnitFullName = orgUnitFullName;
        this.orgUnitRole = orgUnitRole;
        this.orgUnitLevel = orgUnitLevel;
        this.orgUnitType = orgUnitType;
        this.orgUnitAttribute = orgUnitAttribute;
        this.orgUnitGeoZone = orgUnitGeoZone;
        this.parentOrgUnitid = parentOrgUnitid;
        this.hrOrgDeptFlag = hrOrgDeptFlag;
        this.enableState = enableState;
        this.displayorder = displayorder;
    }

    public String getOrgUnitID() {
        return orgUnitID;
    }

    public void setOrgUnitID(String orgUnitID) {
        this.orgUnitID = orgUnitID;
    }

    public String getOrgUnitName() {
        return orgUnitName;
    }

    public void setOrgUnitName(String orgUnitName) {
        this.orgUnitName = orgUnitName;
    }

    public String getOrgUnitFullName() {
        return orgUnitFullName;
    }

    public void setOrgUnitFullName(String orgUnitFullName) {
        this.orgUnitFullName = orgUnitFullName;
    }

    public String getOrgUnitRole() {
        return orgUnitRole;
    }

    public void setOrgUnitRole(String orgUnitRole) {
        this.orgUnitRole = orgUnitRole;
    }

    public String getOrgUnitLevel() {
        return orgUnitLevel;
    }

    public void setOrgUnitLevel(String orgUnitLevel) {
        this.orgUnitLevel = orgUnitLevel;
    }

    public String getOrgUnitType() {
        return orgUnitType;
    }

    public void setOrgUnitType(String orgUnitType) {
        this.orgUnitType = orgUnitType;
    }

    public String getOrgUnitAttribute() {
        return orgUnitAttribute;
    }

    public void setOrgUnitAttribute(String orgUnitAttribute) {
        this.orgUnitAttribute = orgUnitAttribute;
    }

    public String getOrgUnitGeoZone() {
        return orgUnitGeoZone;
    }

    public void setOrgUnitGeoZone(String orgUnitGeoZone) {
        this.orgUnitGeoZone = orgUnitGeoZone;
    }

    public String getParentOrgUnitid() {
        return parentOrgUnitid;
    }

    public void setParentOrgUnitId(String parentOrgUnitid) {
        this.parentOrgUnitid = parentOrgUnitid;
    }

    public String getHrOrgDeptFlag() {
        return hrOrgDeptFlag;
    }

    public void setHrOrgDeptFlag(String hrOrgDeptFlag) {
        this.hrOrgDeptFlag = hrOrgDeptFlag;
    }

    public String getEnableState() {
        return enableState;
    }

    public void setEnableState(String enableState) {
        this.enableState = enableState;
    }

    public String getDisplayorder() {
        return displayorder;
    }

    public void setDisplayorder(String displayorder) {
        this.displayorder = displayorder;
    }



    @Override
    public String toString() {
        return "OrgInfoResponseDTO{" +
                "orgUnitID='" + orgUnitID + '\'' +
                ", orgUnitName='" + orgUnitName + '\'' +
                ", orgUnitFullName='" + orgUnitFullName + '\'' +
                ", orgUnitRole='" + orgUnitRole + '\'' +
                ", orgUnitLevel='" + orgUnitLevel + '\'' +
                ", orgUnitType='" + orgUnitType + '\'' +
                ", orgUnitAttribute='" + orgUnitAttribute + '\'' +
                ", orgUnitGeoZone='" + orgUnitGeoZone + '\'' +
                ", parentOrgUnitid='" + parentOrgUnitid + '\'' +
                ", hrOrgDeptFlag='" + hrOrgDeptFlag + '\'' +
                ", enableState='" + enableState + '\'' +
                ", displayorder='" + displayorder + '\'' +
                '}';
    }
}
