package cn.com.sailfish.linghang.domain;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.time.Instant;
import java.util.Objects;
import java.util.List;

import cn.com.sailfish.linghang.common.auditor.Auditable;

/**
 * @author: AutoCoder (maintained by newma<newma@live.cn>)
 * @create: 2019-07-11 11:19:25
 */

/**
 * 成绩单
 */
@Entity
@Table(name = "report_card")
public class ReportCard extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "score")
    private Float score; // 分数

    @Column(name = "card")
    private String card; // 考试的用户的卡号

    @Column(name = "username")
    private String username; // 考试的用户的名字

    @Column(name = "assessment")
    private Integer assessment; // 评定 0 及格 1 不及格 2 通过 3 不通过

    @Column(name = "remarks")
    private String remarks; // 备注

    @Column(name = "completion_status", nullable = false)
    private Integer completionStatus; // 考试完成状态 0 完成 1 未完成

    @Column(name = "switch_status", nullable = false)
    private Integer switchStatus; // 考试开启状态 0 开启 1 关闭

    @Column(name = "exam_time")
    private Instant examTime; // 参加考试的时间

    @Column(name = "b_is_delete")
    private Boolean biosIsDelete; // 是否已经在回收站中, 默认是false

    @ManyToOne
    @JoinColumn(name = "question_paper_id")
    private QuestionPaper questionPaper;

    @ManyToOne
    @JoinColumn(name = "exam_id")
    private Exam exam;


    // getter and setter

    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Float getScore() {
        return this.score;
    }

    public void setScore(Float score) {
        this.score = score;
    }

    public String getCard() {
        return this.card;
    }

    public void setCard(String card) {
        this.card = card;
    }

    public String getUsername() {
        return this.username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public Integer getAssessment() {
        return this.assessment;
    }

    public void setAssessment(Integer assessment) {
        this.assessment = assessment;
    }

    public String getRemarks() {
        return this.remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public Integer getCompletionStatus() {
        return this.completionStatus;
    }

    public void setCompletionStatus(Integer completionStatus) {
        this.completionStatus = completionStatus;
    }

    public Integer getSwitchStatus() {
        return this.switchStatus;
    }

    public void setSwitchStatus(Integer switchStatus) {
        this.switchStatus = switchStatus;
    }

    public Instant getExamTime() {
        return this.examTime;
    }

    public void setExamTime(Instant examTime) {
        this.examTime = examTime;
    }

    public Boolean getBiosIsDelete() {
        return this.biosIsDelete;
    }

    public void setBiosIsDelete(Boolean biosIsDelete) {
        this.biosIsDelete = biosIsDelete;
    }

    public QuestionPaper getQuestionPaper() {
        return this.questionPaper;
    }

    public void setQuestionPaper(QuestionPaper questionPaper) {
        this.questionPaper = questionPaper;
    }

    public Exam getExam() {
        return this.exam;
    }

    public void setExam(Exam exam) {
        this.exam = exam;
    }


    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "{ ReportCard: { " +
            "'id': '" + getId() + "'" +
            ", 'score': '" + getScore() + "'" +
            ", 'card': '" + getCard() + "'" +
            ", 'username': '" + getUsername() + "'" +
            ", 'assessment': '" + getAssessment() + "'" +
            ", 'remarks': '" + getRemarks() + "'" +
            ", 'completionStatus': '" + getCompletionStatus() + "'" +
            ", 'switchStatus': '" + getSwitchStatus() + "'" +
            ", 'examTime': '" + getExamTime() + "'" +
            ", 'biosIsDelete': '" + getBiosIsDelete() + "'" +
            " }}";
    }
}
