package cn.com.sailfish.linghang.domain;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.time.Instant;
import java.util.Objects;
import java.util.List;

import cn.com.sailfish.linghang.common.auditor.Auditable;

/**
 * @author: AutoCoder (maintained by newma<newma@live.cn>)
 * @create: 2019-07-11 11:19:25
 */

/**
 * 成绩详情
 */
@Entity
@Table(name = "report_card_details")
public class ReportCardDetails extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "special")
    private Integer special; // 是否为特殊题目 默认为否，0:否; 1:是

    @Column(name = "answer")
    private Integer answer; // 代表选项的对错 0 代表错，1代表对

    @Column(name = "choice")
    private String choice; // 代表的是哪个成绩单的哪个项的选择

    @ManyToOne
    @JoinColumn(name = "report_card_id")
    private ReportCard reportCard;

    @ManyToOne
    @JoinColumn(name = "check_item_id")
    private CheckItem checkItem;

    @ManyToOne
    @JoinColumn(name = "exception_message_id")
    private ExceptionItem exceptionItem;

    // getter and setter

    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Integer getSpecial() {
        return this.special;
    }

    public void setSpecial(Integer special) {
        this.special = special;
    }

    public Integer getAnswer() {
        return this.answer;
    }

    public void setAnswer(Integer answer) {
        this.answer = answer;
    }

    public String getChoice() {
        return this.choice;
    }

    public void setChoice(String choice) {
        this.choice = choice;
    }

    public ReportCard getReportCard() {
        return this.reportCard;
    }

    public void setReportCard(ReportCard reportCard) {
        this.reportCard = reportCard;
    }

    public CheckItem getCheckItem() {
        return this.checkItem;
    }

    public void setCheckItem(CheckItem checkItem) {
        this.checkItem = checkItem;
    }

    public ExceptionItem getExceptionItem() {
        return this.exceptionItem;
    }

    public void setExceptionItem(ExceptionItem exceptionItem) {
        this.exceptionItem = exceptionItem;
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "{ ReportCardDetails: { " +
            "'id': '" + getId() + "'" +
            ", 'special': '" + getSpecial() + "'" +
            ", 'answer': '" + getAnswer() + "'" +
            ", 'choice': '" + getChoice() + "'" +
            " }}";
    }
}
