package cn.com.sailfish.linghang.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

@Data
@Entity
@ApiModel(value = "根据关键字查询前端信息视图")
@Table(name="v_select_all_from_crux")
public class SelectAllFromCruxView {

    @Id
    @ApiModelProperty(value = "主键")
    @Column(name="id")
    private Long id;

    @ApiModelProperty(value = "标题")
    @Column(name="title")
    private String title;

    @ApiModelProperty(value="图片位置")
    @Column(name="image_url")
    private String imageUrl;

    @ApiModelProperty(value="创建时间")
    @Column(name = "gmt_created")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    protected Date gmtCreated;

    @ApiModelProperty(value = "简介")
    @Column(name="intro")
    private String intro;

    @ApiModelProperty(value = "内容")
    @Column(name="content")
    private String content;

    @ApiModelProperty(value = "内容")
    @Column(name="classtype")
    private String classtype;

    @ApiModelProperty(value = "二维码url")
    @Column(name="qrcode_url")
    private String qrcodeUrl;

    @ApiModelProperty(value = "数据来源(新闻、课程等等)")
    @Column(name="hard_code")
    private String hardCode;


}
