package cn.com.sailfish.linghang.domain;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.time.Instant;
import java.util.Objects;
import java.util.List;

import cn.com.sailfish.linghang.common.auditor.Auditable;

/**
 * @author: AutoCoder (maintained by newma<newma@live.cn>)
 * @create: 2019-07-11 11:19:25
 */

/**
 * 试卷异常项记录表
 */
@Entity
@Table(name = "test_abnormal_item_info")
public class TestAbnormalItemInfo extends Auditable implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "special")
    private Integer special; // 是否为特殊题目 默认为否，0:否; 1:是

    @ManyToOne
    @JoinColumn(name = "question_paper_id")
    private QuestionPaper questionPaper;

    @ManyToOne
    @JoinColumn(name = "course_id")
    private Course course;

    @ManyToOne
    @JoinColumn(name = "exception_item_id")
    private ExceptionItem exceptionItem;

    // getter and setter

    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Integer getSpecial() {
        return this.special;
    }

    public void setSpecial(Integer special) {
        this.special = special;
    }

    public QuestionPaper getQuestionPaper() {
        return this.questionPaper;
    }

    public void setQuestionPaper(QuestionPaper questionPaper) {
        this.questionPaper = questionPaper;
    }

    public Course getCourse() {
        return this.course;
    }

    public void setCourse(Course course) {
        this.course = course;
    }

    public ExceptionItem getExceptionItem() {
        return this.exceptionItem;
    }

    public void setExceptionItem(ExceptionItem exceptionItem) {
        this.exceptionItem = exceptionItem;
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "{ TestAbnormalItemInfo: { " +
            "'id': '" + getId() + "'" +
            ", 'special': '" + getSpecial() + "'" +
            " }}";
    }
}
