package cn.com.sailfish.linghang.domain;

import cn.com.sailfish.linghang.common.auditor.Auditable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.*;
import java.io.Serializable;

@Data
@Entity
@ApiModel(value = "3D全景图")
@Table(name="thd_model")
public class ThdModel extends Auditable implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @ApiModelProperty(value = "id")
    @Column(name="id")
    private Long id;

    @ApiModelProperty(value = "3d标题")
    @Column(name="thd_title")
    private String  thdTitle;

    @ApiModelProperty(value="图片地址")
    @Column(name="image_url")
    private String imageUrl;

    @ApiModelProperty(value = "状态：0：未发布，1：发布")
    @Column(name="release_statue")
    private Integer releaseStatue;

    @ApiModelProperty(value = "状态：0：失效，1：有效")
    @Column(name="is_del")
    private Integer isDel;

    @ApiModelProperty(value = "简介")
    @Column(name="intro")
    private String intro;

    @ApiModelProperty(value = "序列")
    @Column(name="seqencing")
    private Integer seqencing;

    @ApiModelProperty(value = "强推首页")
    @Column(name="push_index")
    private Integer pushIndex;

    @ApiModelProperty(value = "二级首页置顶")
    @Column(name="second_top")
    private Integer secondTop;

    @ApiModelProperty(value = "二维码url")
    @Column(name="qrcode_url")
    private String qrcodeUrl;

    @ApiModelProperty(value = "压缩包url")
    @Column(name="zip_url")
    private String zipUrl;
}
