package cn.com.sailfish.linghang.domain;

import cn.com.sailfish.linghang.common.auditor.Auditable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.*;
import java.io.Serializable;

@Data
@Entity
@ApiModel(value = "vr全景图")
@Table(name="vr_details")
public class VrDetails extends Auditable implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @ApiModelProperty(value = "主键")
    @Column(name="id")
    private Long id;

    @ApiModelProperty(value = "3D主题")
    @Column(name="vr_title")
    private String vrTitle;

    @ApiModelProperty(value="图片位置")
    @Column(name="image_url")
    private String imageUrl;

    @ApiModelProperty(value="0：未发布 1：发布",example = "0")
    @Column(name="release_statue")
    private Integer releaseStatue;

    @ApiModelProperty(value = "0：失效 1：有效",example = "1")
    @Column(name="is_del")
    private Integer isDel;

    @ApiModelProperty(value = "简介")
    @Column(name="intro")
    private String intro;

    @ApiModelProperty(value = "序列")
    @Column(name="seqencing")
    private Integer seqencing;

    @ApiModelProperty(value = "强推首页")
    @Column(name="push_index")
    private Integer pushIndex;

    @ApiModelProperty(value = "二级首页置顶")
    @Column(name="second_top")
    private Integer secondTop;

    @ApiModelProperty(value = "二维码url")
    @Column(name="qrcode_url")
    private String qrcodeUrl;

    @ApiModelProperty(value = "压缩包url")
    @Column(name="zip_url")
    private String zipUrl;
}
