package cn.com.sailfish.linghang.exception;

import cn.com.sailfish.linghang.common.ErrorConstants;
import cn.com.sailfish.linghang.common.ErrorMessages;

/**
 * Author: huangpeilin
 * Create at: 2018-12-12 14:19:46
 * Description:
 *
 * @author huangpeilin
 */
public class ServerErrorException extends Exception {
    private int errorCode;

    public ServerErrorException(int errorCode, String message) {
        super(message);
        this.errorCode = errorCode;
    }

    public ServerErrorException(String message) {
        super(message);
        this.errorCode = ErrorConstants.ERR_UNKNOWN;
    }

    public ServerErrorException(int errorCode) {
        super(ErrorMessages.getErrorMessage(errorCode));
        this.errorCode = errorCode;
    }

    public int getErrorCode() {
        return errorCode;
    }

    public void setErrorCode(int errorCode) {
        this.errorCode = errorCode;
    }
}
