package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.Area;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Author: AutoCoder (maintained by newma<newma@live.cn>)
 * Create: 2019-04-23 15:12:04
 * @Author huangpeilin
 */

@Repository
public interface AreaRepository extends JpaRepository<Area, Long> {

    /**
     * 根据区域名字查找区域
     * @param name 区域名字
     * @return
     */
    Area findOneByName(String name);

    /**
     * 根据ID查询区域
     * @param areaId 区域ID
     * @return
     */
    Area findOneById(Long areaId);

    /**
     * 根据区域ID和职位查询区域信息
     * @param areaId 区域ID
     * @param position 职位
     * @return
     */
    Area findOneByIdAndPosition(Long areaId, Integer position);

    /**
     * 根据职位查找区域
     * @param position
     * @return
     */
    List<Area> findAllByPosition(Integer position);
}