package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.BannerDetails;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

public interface BannerRepository extends JpaRepository<BannerDetails, Long> {

    @Query("select b from BannerDetails b where b.isDel = '0' and b.id = :id")
    BannerDetails findBannerDetailsById(long id);

    @Query("SELECT auth FROM BannerDetails auth WHERE auth.isDel ='0' AND auth.id = :id ")
    BannerDetails findByIdAndSeqencing(long id);

    @Transactional
    @Modifying
    @Query("UPDATE BannerDetails v SET v.seqencing = v.seqencing+1 WHERE v.id = :id")
    void backward(Long id);

    @Transactional
    @Modifying
    @Query("UPDATE BannerDetails v SET v.seqencing = v.seqencing-1 WHERE v.id = :id")
    void forward(Long id);

    @Transactional
    @Modifying
    @Query("UPDATE BannerDetails v SET v.isDel='1' WHERE v.id = :id")
    void fakedel(Long id);
}
