package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.CourseIntroduce;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface CourseIntroduceRepository extends JpaRepository<CourseIntroduce,Long> {

    @Query( "select  c from  CourseIntroduce c where c.isDel='0' and c.id=:id")
    CourseIntroduce findCourseIntroducesById(long id);

    @Transactional
    @Modifying
    @Query("UPDATE CourseIntroduce v SET v.seqencing=v.seqencing+1 WHERE v.id = :id")
    void backward(Long id);

    @Transactional
    @Modifying
    @Query("UPDATE CourseIntroduce v SET v.seqencing=v.seqencing-1 WHERE v.id = :id")
    void forward(Long id);

    @Query(nativeQuery = true, value = "SELECT * FROM course_introduce v WHERE v.seqencing!='1' AND v.id = :id ")
    CourseIntroduce findByIdAndSeqencing(long id);

    @Query("SELECT auths FROM CourseIntroduce auths " +
            " WHERE auths.courseTitle LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " +
            " OR auths.intro LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " )
    Page<CourseIntroduce> findpage(String crux, Pageable pageable);

    @Transactional
    @Modifying
    @Query("UPDATE CourseIntroduce v SET v.isDel='1' WHERE v.id = :id")
    void fakedel(Long id);

    @Query("SELECT v FROM CourseIntroduce v WHERE v.seqencing = :seqencing AND v.isDel= '0' ")
    List<CourseIntroduce> findBySeqencing(Integer seqencing);


    @Query( "SELECT v FROM CourseIntroduce v WHERE v.pushIndex = '1' AND v.isDel= '0' ")
    List<CourseIntroduce> findCourseByPushIndex();
}
