package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.Course;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

/**
 * Author: AutoCoder (maintained by newma<newma@live.cn>)
 * Create: 2019-04-23 15:12:04
 * @author huangpeilin
 */

@Repository
public interface CourseRepository extends JpaRepository<Course, Long> {

    /**
     * 通过课程ID查找课程
     * @param id
     * @return
     */
    Course findOneById(Long id);

    /**
     * 根据课程的英文名字查找课程
     * @param courseName
     * @return
     */
    Course findOneByName(String courseName);

    /**
     * 根据导入的课程ID查找课程
     * @param courseId
     * @return
     */
    Course findOneByImportId(Long courseId);
}