package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.ImageDetails;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Repository
public interface ImageDetailsRepository extends JpaRepository<ImageDetails,Long> {

    @Transactional
    @Modifying
    @Query("UPDATE ImageDetails i SET i.isDel=1 WHERE i.id = :id")
    public void fakedel(Long id);



    @Query("SELECT auths FROM ImageDetails auths " +
            " WHERE auths.name LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " +
            "AND auths.sourceType in :sourceType")
    Page<ImageDetails> findAllbysourceTypeAndCrux(String crux, Pageable pageable, List<String> sourceType);

    @Query("SELECT auths FROM ImageDetails auths " +
            " WHERE auths.isDel = '0' " +
            "AND auths.sourceType in :sourceType")
    Page<ImageDetails> findAllbysourceType(Pageable pageable, List<String> sourceType);
}
