package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.Model;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Author: AutoCoder (maintained by newma<newma@live.cn>)
 * Create: 2019-04-23 15:12:04
 *
 * @author huangpeilin
 */

@Repository
public interface ModelRepository extends JpaRepository<Model, Long> {

    /**
     * 根据飞机品牌查询机型
     * @param brand
     * @return
     */
    List<Model> findAllByBrand(String brand);

    /**
     * 根据机型ID查找机型
     * @param id
     * @return
     */
    Model findOneById(Long id);

    /**
     * 根据机型和名字对应的值查找机型
     * @param planeModel
     * @return
     */
    Model findOneByNameType(Integer planeModel);

    /**
     * 根据机型和飞机制造商名字对应的值查找机型
     * @param planeModel
     * @param airFramer
     * @return
     */
    Model findOneByNameTypeAndBrandType(Integer planeModel, Integer airFramer);
}