package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.NewsPaper;
import cn.com.sailfish.linghang.domain.ThdModel;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Repository
public interface NewsPaperRepository extends JpaRepository<NewsPaper, Long> {

    @Query( "select  n from  NewsPaper n where n.isDel='0' and n.id=:id")
    NewsPaper findnewsPaperById(long id);

    @Transactional
    @Modifying
    @Query("UPDATE NewsPaper v SET v.seqencing=v.seqencing+1 WHERE v.id = :id")
    void backward(Long id);

    @Transactional
    @Modifying
    @Query("UPDATE NewsPaper v SET v.seqencing=v.seqencing-1 WHERE v.id = :id")
    void forward(Long id);

    @Query(nativeQuery = true, value = "SELECT * FROM new_papers v WHERE v.seqencing!='1' AND v.id = :id ")
    NewsPaper findByIdAndSeqencing(long id);

    @Query("SELECT auths FROM NewsPaper auths " +
            " WHERE auths.newsTitle LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " +
            " OR auths.intro LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " )
    Page<NewsPaper> findpage(String crux, Pageable pageable);

    @Transactional
    @Modifying
    @Query("UPDATE NewsPaper v SET v.isDel='1' WHERE v.id = :id")
    void fakedel(Long id);

    @Query("SELECT auths FROM NewsPaper auths " +
            " WHERE auths.newsTitle LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " +
            "AND auths.classtype = '1' "+
            " OR auths.intro LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' "+
            "AND auths.classtype = '1' ")
    Page<NewsPaper> findpagexinwen(String crux, Pageable pageable);

    @Query("SELECT auths FROM NewsPaper auths " +
            " WHERE auths.newsTitle LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " +
            "AND auths.classtype = '2' "+
            " OR auths.intro LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' "+
            "AND auths.classtype = '2' ")
    Page<NewsPaper> findpagehangye(String crux, Pageable pageable);

    @Query("SELECT v FROM NewsPaper v WHERE v.seqencing = :seqencing AND v.isDel= '0' ")
    List<NewsPaper> findBySeqencing(Integer seqencing);

    @Query( "SELECT v FROM NewsPaper v WHERE v.pushIndex = '1' AND v.isDel= '0' ")
    List<NewsPaper> findNewsPaperByPushIndex();
}
