package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.CheckItem;
import cn.com.sailfish.linghang.domain.ExceptionItem;
import cn.com.sailfish.linghang.domain.ReportCard;
import cn.com.sailfish.linghang.domain.ReportCardDetails;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Author: AutoCoder (maintained by newma<newma@live.cn>)
 * Create: 2019-04-23 15:12:04
 *
 * @author
 */

@Repository
public interface ReportCardDetailsRepository extends JpaRepository<ReportCardDetails, Long> {

    /**
     * 根据成绩单获取所有成绩单详情
     * @param reportCard
     * @return
     */
    List<ReportCardDetails> findAllByReportCard(ReportCard reportCard);

    /**
     * 根据成绩单和检查项不为空查找成绩详情
     * @param reportCard
     * @return
     */
    List<ReportCardDetails> findAllByReportCardAndCheckItemIsNotNull(ReportCard reportCard);

    /**
     * 根据成绩单和检查项查找检查项的详细信息
     * @param reportCard
     * @param checkItem
     * @return
     */
    ReportCardDetails findOneByReportCardAndCheckItem(ReportCard reportCard, CheckItem checkItem);

    /**
     * 根据成绩单和异常项(特殊项)查找成绩详情
     * @param reportCard
     * @param exceptionItem
     * @param special
     * @return
     */
    ReportCardDetails findOneByReportCardAndExceptionItemAndSpecial(ReportCard reportCard, ExceptionItem exceptionItem, int special);

    /**
     * 根据成绩单和异常项(特殊项)查找成绩详情
     * @param reportCard
     * @param exceptionItem
     * @param special
     * @return
     */
    List<ReportCardDetails> findByReportCardAndAndExceptionItemAndSpecial(ReportCard reportCard, ExceptionItem exceptionItem, int special);
}