package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.SelectAllFromCruxView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

@Repository
public interface SelectAllFromCruxViewRepository extends JpaRepository<SelectAllFromCruxView, Long> {

    /**
     * 功能描述：查询全部分类
     * @param crux
     * @param pageable
     * @return
     */
    @Query("SELECT v FROM SelectAllFromCruxView v WHERE v.title LIKE CONCAT('%', :crux, '%')")
    Page<SelectAllFromCruxView> findpage(String crux, Pageable pageable);

    /**
     * 功能描述：
     * @param pageable
     * @return
     */
    @Query("SELECT v FROM SelectAllFromCruxView v WHERE v.hardCode = 'newspaper' AND v.classtype = '1'")
    Page<SelectAllFromCruxView> newspaperFindPage(Pageable pageable);

    /**
     * 功能描述：查询【新闻资讯】
     * @param crux
     * @param pageable
     * @return
     */
    @Query("SELECT v FROM SelectAllFromCruxView v WHERE v.hardCode = 'newspaper' AND v.classtype = '1' AND v.title LIKE CONCAT('%', :crux, '%')")
    Page<SelectAllFromCruxView> newspaperFindPageBycrux(String crux, Pageable pageable);

    /**
     * 功能描述：
     * @param pageable
     * @return
     */
    @Query("SELECT v FROM SelectAllFromCruxView v WHERE v.hardCode = 'newspaper' AND v.classtype = '2'")
    Page<SelectAllFromCruxView> hangyeFindPage(Pageable pageable);

    /**
     * 功能描述：查询【行业信息】
     * @param crux
     * @param pageable
     * @return
     */
    @Query("SELECT v FROM SelectAllFromCruxView v WHERE v.hardCode = 'newspaper' AND v.classtype = '2' AND v.title LIKE CONCAT('%', :crux, '%')")
    Page<SelectAllFromCruxView> hangyeFindPageBycrux(String crux, Pageable pageable);

    /**
     * 功能描述：
     * @param pageable
     * @return
     */
    @Query("SELECT v FROM SelectAllFromCruxView v WHERE v.hardCode = 'course' ")
    Page<SelectAllFromCruxView> courseFindPage(Pageable pageable);

    /**
     * 功能描述：查询【课程介绍】
     * @param crux
     * @param pageable
     * @return
     */
    @Query("SELECT v FROM SelectAllFromCruxView v WHERE v.hardCode = 'course' AND v.title LIKE CONCAT('%', :crux, '%')")
    Page<SelectAllFromCruxView> courseFindPageBycrux(String crux, Pageable pageable);

    /**
     * 功能描述：
     * @param pageable
     * @return
     */
    @Query("SELECT v FROM SelectAllFromCruxView v WHERE v.hardCode = 'vrdetails'")
    Page<SelectAllFromCruxView> vrDetailsFindPage(Pageable pageable);

    /**
     * 功能描述：查询【VR全景图】
     * @param crux
     * @param pageable
     * @return
     */
    @Query("SELECT v FROM SelectAllFromCruxView v WHERE v.hardCode = 'vrdetails' AND v.title LIKE CONCAT('%', :crux, '%')")
    Page<SelectAllFromCruxView> vrDetailsFindPageBycrux(String crux, Pageable pageable);

}


