package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.Course;
import cn.com.sailfish.linghang.domain.ExceptionItem;
import cn.com.sailfish.linghang.domain.QuestionPaper;
import cn.com.sailfish.linghang.domain.TestAbnormalItemInfo;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Author: AutoCoder (maintained by newma<newma@live.cn>)
 * Create: 2019-04-23 15:12:04
 *
 * @author huangpeilin
 */

@Repository
public interface TestAbnormalItemInfoRepository extends JpaRepository<TestAbnormalItemInfo, Long> {

    /**
     * 根据试卷，课程和是否为特殊项查找异常项
     * @param questionPaper 试卷
     * @param course 课程
     * @param special 是否为特殊项 0 不是 1 是
     * @return
     */
    List<TestAbnormalItemInfo> findAllByQuestionPaperAndCourseAndSpecial(QuestionPaper questionPaper, Course course, Integer special);

    /**
     * 获取特殊项
     * @param questionPaper
     * @param exceptionItem
     * @param special
     * @return
     */
    TestAbnormalItemInfo findOneByQuestionPaperAndExceptionItemAndSpecial(QuestionPaper questionPaper, ExceptionItem exceptionItem, Integer special);
}