package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.ThdModel;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface ThdModelRepository extends JpaRepository<ThdModel,Long> {



    @Query( "select  t from  ThdModel t where t.isDel='0' and t.id=:id")
    ThdModel findThdModelById(long id);

    @Transactional
    @Modifying
    @Query("UPDATE ThdModel v SET v.seqencing=v.seqencing+1 WHERE v.id = :id")
    void backward(Long id);

    @Transactional
    @Modifying
    @Query("UPDATE ThdModel v SET v.seqencing=v.seqencing-1 WHERE v.id = :id")
    void forward(Long id);


    @Query(nativeQuery = true, value = "SELECT * FROM thd_model v WHERE v.seqencing!='1' AND v.id = :id ")
    ThdModel findByIdAndSeqencing(long id);

    @Query("SELECT auths FROM ThdModel auths " +
            " WHERE auths.thdTitle LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " +
            " OR auths.intro LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " )
    Page<ThdModel> findpage(String crux, Pageable pageable);

    @Transactional
    @Modifying
    @Query("UPDATE ThdModel v SET v.isDel='1' WHERE v.id = :id")
    void fakedel(Long id);

    @Query("SELECT v FROM ThdModel v WHERE v.seqencing = :seqencing AND v.isDel= '0' ")
    List<ThdModel> findBySeqencing(Integer seqencing);

    @Query( "SELECT v FROM ThdModel v WHERE v.pushIndex = '1' AND v.isDel= '0' ")
    List<ThdModel> findModelByPushIndex();
}
