package cn.com.sailfish.linghang.repository;

import cn.com.sailfish.linghang.domain.VrDetails;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface VrPanoramaRepository extends JpaRepository<VrDetails, Long> {

    @Query("select  v from  VrDetails v where v.isDel='0' and v.id=:id")
    VrDetails findVrDetailsById(long id);

    @Transactional
    @Modifying
    @Query("UPDATE VrDetails v SET v.seqencing = v.seqencing + 1 WHERE v.id = :id")
    void backward(Long id);

    @Transactional
    @Modifying
    @Query("UPDATE VrDetails v SET v.seqencing = v.seqencing - 1 WHERE v.id = :id")
    void forward(Long id);

    @Query(nativeQuery = true, value = "SELECT * FROM vr_details v WHERE v.seqencing!='1' AND v.id = :id ")
    VrDetails findByIdAndSeqencing(long id);

    @Query("SELECT auths FROM VrDetails auths " +
            "WHERE auths.vrTitle LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' " +
            "OR auths.intro LIKE CONCAT('%', :crux, '%') " +
            "AND auths.isDel = '0' ")
    Page<VrDetails> findpage(String crux, Pageable pageable);

    @Transactional
    @Modifying
    @Query("UPDATE VrDetails v SET v.isDel='1' WHERE v.id = :id")
    void fakedel(Long id);

    @Query( "SELECT v FROM VrDetails v WHERE v.seqencing = :seqencing AND v.isDel= '0' ")
    List<VrDetails> findBySeqencing(Integer seqencing);

    @Query( "SELECT v FROM VrDetails v WHERE v.pushIndex = '1' AND v.isDel= '0' ")
    List<VrDetails> findVrDetailsByPushIndex();
}
