package cn.com.sailfish.linghang.security;

import cn.com.sailfish.linghang.domain.User;
import cn.com.sailfish.linghang.repository.UserRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Component;

import java.util.Optional;

/**
 * Author: huangpeilin
 * Create at: 2018-12-12 14:09:16
 * Description:
 *
 * @author huangpeilin
 */
@Component("userDetailsService")
public class DomainUserDetailsService implements UserDetailsService {
    private Logger log = LoggerFactory.getLogger(DomainUserDetailsService.class);

    @Autowired
    UserRepository userRepository;

    @Override
    public UserDetails loadUserByUsername(String login) throws UsernameNotFoundException {
        Optional<User> userFromDatabase = userRepository.findOneByCard(login);
        if(!userFromDatabase.isPresent()) {
            log.info("Not found user by card {}, try to found with user phone", login);
            userFromDatabase = userRepository.findOneByMobilePhone(login);
        }

        return userFromDatabase.map(user -> {
            return new JWTUser(user.getCard(), user.getPassword(), user.getAuthority());
        }).orElseThrow(() -> new UsernameNotFoundException("User " + login + " was not found in the " +
                "database"));
    }
}
