package cn.com.sailfish.linghang.service;

import cn.com.sailfish.linghang.dao.web.request.BannerSecondRequestDTO;
import cn.com.sailfish.linghang.dao.web.response.WebSumResponseDTO;
import cn.com.sailfish.linghang.dao.web.response.WebVrSumResponseDTO;
import cn.com.sailfish.linghang.domain.CourseIntroduce;
import cn.com.sailfish.linghang.domain.NewsPaper;
import cn.com.sailfish.linghang.domain.VrDetails;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;

@Service
public class EntityManagerService {
    @Resource
    private EntityManager entityManager;

    /**
     *
     * description 查询系统内的课程；
     * @return List<String>
     */
    public List<String> findAllChineseName(){
        String sql="SELECT  chinese_name FROM course";
        Query query=entityManager.createNativeQuery(sql);
        List<String> list=query.getResultList();
        return  list;
    }

    /**
     * description 查询系统内的所有部门；
     * @return List<String>
     */
    public List<String> findAllDISrgUnitFullName(){
        String sql="select DISTINCT(org_unit_fullname) FROM org_info_form";
        Query query=entityManager.createNativeQuery(sql);
        List<String> list=query.getResultList();
        return  list;
    }

    /**
     * description 查询单个部门的 数据统计展示；
     * @param deptment
     * @param course
     * @param type
     * @param startTime
     * @param endTime
     * @return List<WebVrSumResponseDTO>
     */
    public WebVrSumResponseDTO findsum(String deptment ,String course ,String type ,String startTime,String endTime ){
        String sql="SELECT\n" +
                "\tcount( 1 ) AS usercount,\n" +
                "\tSEC_TO_TIME(\n" +
                "\t\tSUM(\n" +
                "\t\t\tTIME_TO_SEC(\n" +
                "\t\t\tTIMEDIFF( op.logout_time, op.login_time )))) AS usertime,\n" +
                "\t'所有' as deptment,\n" +
                "\t'所有' AS course,\n" +
                "\t'所有' AS type,\n" +
                "\t'所有' AS partrtime \n" +
                "FROM\n" +
                "\torg_info_form o\n" +
                "\tINNER JOIN user_info_form u ON o.org_unit_id = u.org_unit_id\n" +
                "\tINNER JOIN operation_record op ON u.empId = op.card \n" +
                "INNER JOIN\n" +
                "\tquestion_paper qp\n" +
                "\t ON qp.title=op.type_name\n" +
                "\tINNER JOIN\n" +
                "\tcourse ce\n" +
                "\tON qp.course_id=ce.id\n"+
                "WHERE\n" +
                "\t1 = 1\n" +
                "AND IF\n" +
                "\t(?1!='', o.org_unit_fullname =?1,1 = 1 ) \n" +
                "AND\n" +
                "\t IF\n" +
                "\t(?2!='', ce.chinese_name=?2,1 = 1 ) \n" +
                "AND\n" +
                "\tIF\n" +
                "\t(?3!='', op.type =?3,1 = 1 ) \n" +
                "AND\n" +
                "\tIF\n" +
                "\t(?4!='', op.gmt_modified >STR_TO_DATE(?4, '%Y-%m-%d'), 1 = 1 ) \n" +
                "\tAND\n" +
                "IF\n" +
                "\t(?5!='', op.gmt_modified < STR_TO_DATE(?5, '%Y-%m-%d'),1 = 1 )";
                Query query=entityManager.createNativeQuery(sql,WebVrSumResponseDTO.class);
                if(null!=deptment){
                    query.setParameter(1,deptment);}
                else{
                    query.setParameter(1,"");
                }
                if(null!=course){
                    query.setParameter(2,course);}
                else{
                    query.setParameter(2,"");
                }
                if(null!=type){
                    query.setParameter(3,type);}
                else{
                    query.setParameter(3,"");
                }
                if (null!=startTime) {
                    query.setParameter(4, startTime);
                }else{
                    query.setParameter(4, "");
                }
                if (null!=endTime) {
                    query.setParameter(5, endTime);
                }else{
                    query.setParameter(5, "");
                }
                WebVrSumResponseDTO webVrSumResponseDTO= (WebVrSumResponseDTO) query.getSingleResult();;
                return  webVrSumResponseDTO;
    }

    /**
     * description 查询所有部门展示总和；
     * @param course
     * @param type
     * @param startTime
     * @param endTime
     * @return WebVrSumResponseDTO
     */
    public List<WebVrSumResponseDTO> findGrodSum(String course ,String type ,String startTime,String endTime){
        String sql="SELECT\n" +
                "\tSEC_TO_TIME(\n" +
                "\t\tSUM(\n" +
                "\t\t\tTIME_TO_SEC(\n" +
                "\t\t\tTIMEDIFF(op.logout_time, op.login_time)))) AS usertime,\n" +
                "\tcount( 1 ) AS usercount,\n" +
                "\to.org_unit_fullname as deptment,\n" +
                "\t'所有' AS course,\n" +
                "\t'所有' AS type,\n" +
                "\t'所有' AS partrtime \n" +
                "\tFROM\n" +
                "\torg_info_form o\n" +
                "\tINNER JOIN user_info_form u ON o.org_unit_id = u.org_unit_id\n" +
                "\tINNER JOIN operation_record op ON u.empId = op.card \n" +
                "\tINNER JOIN\n" +
                "\tquestion_paper qp\n" +
                "\tON  qp.title=op.type_name\n" +
                "\tINNER JOIN\n" +
                "\tcourse ce\n" +
                "\tON  qp.course_id=ce.id\n"+
                "WHERE\n" +
                "\t1 = 1 \n" +
                "AND\n" +
                "IF\n" +
                "\t(?1!= '', ce.chinese_name =?1, 1 = 1 ) \n" +
                "AND\n" +
                "IF\n" +
                "\t(?2!= '', op.type =?2, 1 = 1 ) \n" +
                "AND\n" +
                "IF\n" +
                "\t(?3!= '', op.gmt_modified > STR_TO_DATE(?3,'%Y-%m-%d'), 1 = 1 ) \n" +
                "AND\n" +
                "IF\n" +
                "\t(?4!= '', op.gmt_modified < STR_TO_DATE(?4,'%Y-%m-%d'), 1 = 1 )"+
                 "\t GROUP BY org_unit_fullname";
                Query query=entityManager.createNativeQuery(sql,WebVrSumResponseDTO.class);
                if(null!=course){
                    query.setParameter(1,course);}
                else{
                    query.setParameter(1,"");
                }
                if(null!=type){
                    query.setParameter(2,type);}
                else{
                    query.setParameter(2,"");
                }
                if (null!=startTime) {
                    query.setParameter(3, startTime);
                }else{
                    query.setParameter(3, "");
                }
                if (null!=endTime) {
                    query.setParameter(4, endTime);
                }else{
                    query.setParameter(4, "");
                }
                List<WebVrSumResponseDTO> list= query.getResultList();
                return  list;
    }
    public WebVrSumResponseDTO findAllSum(String course ,String type ,String startTime,String endTime){
        String sql="SELECT\n" +
                "\tSEC_TO_TIME(\n" +
                "\t\tSUM(\n" +
                "\t\t\tTIME_TO_SEC(\n" +
                "\t\t\tTIMEDIFF(op.logout_time, op.login_time)))) AS usertime,\n" +
                "\tcount( 1 ) AS usercount,\n" +
                "\t'所有' as deptment,\n" +
                "\t'所有' AS course,\n" +
                "\t'所有' AS type,\n" +
                "\t'所有' AS partrtime \n" +
                "FROM\n" +
                "\torg_info_form o\n" +
                "\tINNER JOIN user_info_form u ON o.org_unit_id = u.org_unit_id\n" +
                "\tINNER JOIN operation_record op ON u.empId = op.card \n" +
                "\tINNER JOIN\n" +
                "\tquestion_paper qp\n" +
                "\tON qp.title=op.type_name\n" +
                "\tINNER JOIN\n" +
                "\tcourse ce\n" +
                "\tON  qp.course_id=ce.id\n"+
                "WHERE\n" +
                "\t1 = 1 \n"+
                "AND\n" +
                "IF\n" +
                "\t(?1!= '', ce.chinese_name =?1, 1 = 1 ) \n" +
                "AND\n" +
                "IF\n" +
                "\t(?2!= '', op.type =?2, 1 = 1 ) \n" +
                "AND\n" +
                "IF\n" +
                "\t(?3!= '', op.gmt_modified > STR_TO_DATE(?3,'%Y-%m-%d'), 1 = 1 ) \n" +
                "AND\n" +
                "IF\n" +
                "\t(?4!= '', op.gmt_modified < STR_TO_DATE(?4,'%Y-%m-%d'), 1 = 1 )";
               Query query=entityManager.createNativeQuery(sql,WebVrSumResponseDTO.class);
                if(null!=course){
                    query.setParameter(1,course);}
                else{
                    query.setParameter(1,"");
                }
                if(null!=type){
                    query.setParameter(2,type);}
                else{
                    query.setParameter(2,"");
                }
                if (null!=startTime) {
                    query.setParameter(3, startTime);
                }else{
                    query.setParameter(3, "");
                }
                if (null!=endTime) {
                    query.setParameter(4, endTime);
                }else{
                    query.setParameter(4, "");
                }

        WebVrSumResponseDTO webVrSumResponseDTO= (WebVrSumResponseDTO) query.getSingleResult();;
        return  webVrSumResponseDTO;
    }
    /**
     * description 测试；
     * @return
     */
    public String findAllDISrgUnitFullName111(){
        String sql="select name from area where 1=1 AND if (?0!='',id=?0,id=3)";
        Query query=entityManager.createNativeQuery(sql);
        query.setParameter(0,4);
        return (String) query.getSingleResult();
    }

    public List<WebSumResponseDTO> findWebSum(String type, String startTime, String endTime){
        String sql="SELECT\n" +
                "\td.type,\n" +
                "\tcount(1) as usercount,\n" +
                "\tSEC_TO_TIME(\n" +
                "\t\tSUM(\n" +
                "\t\t\tTIME_TO_SEC(\n" +
                "\t\t\tTIMEDIFF(d.gmt_modified, d.gmt_created)))) as usertimecount,\n" +
                "\t'所有' AS parttime \n" +
                "FROM\n" +
                "\tdata_statistics d\n" +
                "\tWHERE\n" +
                "\t1 = 1 \n" +
                "AND\n" +
                "IF\n" +
                "\t(?1!='', type =?1, 1 = 1 ) \n" +
                "AND\n" +
                "IF\n" +
                "\t(?2!='', d.gmt_modified > STR_TO_DATE(?2, '%Y-%m-%d'), 1 = 1 ) \n" +
                "AND\n" +
                "IF\n" +
                "\t(?3!='', d.gmt_modified < STR_TO_DATE(?3, '%Y-%m-%d'), 1 = 1 )"+
                "GROUP BY d.type";
            Query query=entityManager.createNativeQuery(sql,WebSumResponseDTO.class);
            if(null!=type){
                query.setParameter(1,type);}
            else{
                query.setParameter(1,"");
            }
            if (null!=startTime) {
                query.setParameter(2, startTime);
            }else{
                query.setParameter(2, "");
            }
            if (null!=endTime) {
                query.setParameter(3, endTime);
            }else{
                query.setParameter(3, "");
            }
            List<WebSumResponseDTO> webList=query.getResultList();

        return webList;
    }
    public List<CourseIntroduce> findCourseIntroduceBycrux(String crux){

        String sql="SELECT * FROM course_introduce n WHERE n.course_title LIKE '%'||?1||'%' and n.content  LIKE '%'||?1||'%' and statue='1' UNION SELECT * FROM course_introduce n WHERE n.content LIKE '%'||?1||'%' and n.content  LIKE '%'||?1||'%' and statue='1'";

        Query query=entityManager.createNativeQuery(sql,CourseIntroduce.class);

        query.setParameter(1,crux);

        List<CourseIntroduce> courseIntroduceList =query.getResultList();
        return courseIntroduceList;
    }

    public List<NewsPaper> findNewsPaperBycrux(String crux){
        String sql="SELECT * FROM new_papers n WHERE  n.classtype='1' and n.new_title LIKE '%'||?1||'%' and n.content  LIKE '%'||?1||'%' and statue='1' UNION SELECT * FROM new_papers n WHERE n.classtype='1' and n.content LIKE '%'||?1||'%' and n.content  LIKE '%'||?1||'%' and statue='1'";

        Query query=entityManager.createNativeQuery(sql,NewsPaper.class);

        query.setParameter(1,crux);

        List<NewsPaper> newspaperlist=query.getResultList();
        return newspaperlist;

    }

    public List<NewsPaper> findNewsPaperindustryBycrux(String crux){
        String sql="SELECT * FROM new_papers n WHERE  classtype='2' and n.new_title LIKE '%'||?1||'%' and n.content  LIKE '%'||?1||'%' and statue='1' UNION SELECT * FROM new_papers n WHERE n.classtype='2' and n.content LIKE '%'||?1||'%'and n.content  LIKE '%'||?1||'%' and statue='1'";

        Query query=entityManager.createNativeQuery(sql,NewsPaper.class);

        query.setParameter(1,crux);

        List<NewsPaper> newspaperlist=query.getResultList();
        return newspaperlist;

    }

    public List<VrDetails> findVrmodelBycrux(String crux){

        String sql="SELECT * FROM vr_details n WHERE n.vr_images_title LIKE '%'||?1||'%' and n.content  LIKE '%'||?1||'%' and statue='1' UNION SELECT * FROM vr_details n WHERE n.vr_images_title LIKE '%'||?1||'%'  and n.content  LIKE '%'||?1||'%' and statue='1'";

        Query query=entityManager.createNativeQuery(sql,VrDetails.class);

        query.setParameter(1,crux);

        List<VrDetails> vrDetailsList =query.getResultList();
        return vrDetailsList;
    }
    public List<BannerSecondRequestDTO> findbyallcrux(String crux,Integer page ,Integer pagesize){
        String sql="SELECT new_title AS title,content,classtype AS type,new_url AS url,gmt_created AS creattime FROM new_papers WHERE title LIKE '%'||?1||'%' and id between ?2 and ?3 \n" +
                "UNION ALL\n" +
                "SELECT course_title AS title,content,'2' AS type,course_url as url,gmt_created as creattime FROM\n" +
                "course_introduce title LIKE '%'||?1||'%' and id between ?2 and ?3\n" +
                "UNION ALL\n" +
                "SELECT vr_images_title AS title,content ,'3' AS type,image_url as url,gmt_created as creattime FROM\n" +
                "vr_details title LIKE '%'||?1||'%' and id between ?2 and ?3 \n" +
                "UNION ALL\n" +
                "SELECT thd_title AS title,'2' as content, '4' AS type,image_url AS url ,gmt_created as creattime FROM thd_model title LIKE '%'||?1||'%' and id between ?2 and ?3";

        Query query=entityManager.createNativeQuery(sql,BannerSecondRequestDTO.class);
        query.setParameter(1,crux);
        query.setParameter(2,page*pagesize);
        query.setParameter(3,pagesize);

        List<BannerSecondRequestDTO> bannerSecondRequestDTO =query.getResultList();
        return bannerSecondRequestDTO;
    }


}
