package cn.com.sailfish.linghang.service.admin;

import cn.com.sailfish.linghang.dao.web.response.PageResponse;
import cn.com.sailfish.linghang.domain.BannerDetails;
import cn.com.sailfish.linghang.domain.OperateDto.BannerDetailsOperateDto;
import cn.com.sailfish.linghang.domain.OperateDto.ListDto;
import cn.com.sailfish.linghang.repository.BannerRepository;
import io.micrometer.core.instrument.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.*;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Optional;

@Service
public class BannerManageAdminService {


    @Autowired
    private BannerRepository bannerRepository;

    public BannerDetails findById(String id) {
        return bannerRepository.findBannerDetailsById(Long.valueOf(id));
    }

    public void changeBannerOn(String id) {
        BannerDetails vrbannerDetail = bannerRepository.findBannerDetailsById(Long.valueOf(id));
        if (vrbannerDetail != null) {
            if (vrbannerDetail.getBannerOn() == 0) {
                vrbannerDetail.setBannerOn(1);
            } else {
                vrbannerDetail.setBannerOn(0);
            }
            bannerRepository.save(vrbannerDetail);
        }
    }

    /**
     * @param id
     * @description 前移方法
     */
    public void forward(long id) {
        BannerDetails bannerDetails = bannerRepository.findByIdAndSeqencing(id);
        if (bannerDetails != null) {
            bannerRepository.forward(id);
        }
    }

    /**
     * description 后移方法
     *
     * @param id
     * @return
     */
    public void backward(long id) {
        bannerRepository.backward(id);
    }

    public PageResponse<BannerDetails> pagebystatue(Integer page, Integer pageSize) {

        BannerDetails bannerDetails = new BannerDetails();

        bannerDetails.setIsDel(0);

        Example<BannerDetails> example = Example.of(bannerDetails, ExampleMatcher.matching());

        List<Sort.Order> orders = new ArrayList<>();
        orders.add(new Sort.Order(Sort.Direction.DESC, "bannerOn"));
        orders.add(new Sort.Order(Sort.Direction.ASC, "seqencing"));
        orders.add(new Sort.Order(Sort.Direction.DESC, "gmtCreated"));

        Pageable pageable = PageRequest.of(page - 1, pageSize, new Sort(orders));
        Page<BannerDetails> vrDetailPage = bannerRepository.findAll(example, pageable);
        return BannerDetailsPageResponse(vrDetailPage);
    }

    public synchronized PageResponse<BannerDetails> BannerDetailsPageResponse(Page<BannerDetails> newscourseIntroduce) {
        PageResponse pageResponse = new PageResponse();
        if (newscourseIntroduce != null) {
            pageResponse.setPageIndex(newscourseIntroduce.getPageable().getPageNumber() + 1);
            pageResponse.setPageSize(newscourseIntroduce.getPageable().getPageSize());
            pageResponse.setTotalCount(newscourseIntroduce.getTotalElements());
            pageResponse.setTotalPageCount(newscourseIntroduce.getTotalPages());
            pageResponse.setList(newscourseIntroduce.getContent());
        }
        return pageResponse;
    }

    public void saveOrUpdate(BannerDetailsOperateDto bannerDetailsOperateDto) {
        BannerDetails _bannerDetails = new BannerDetails();
        _bannerDetails.setGmtModified(new Date());
        if (StringUtils.isEmpty(String.valueOf(bannerDetailsOperateDto.getId())) | bannerDetailsOperateDto.getId() == null) {
            _bannerDetails.setGmtCreated(new Date());
            _bannerDetails.setIsDel(0);
            _bannerDetails.setReleaseStatue(0);
            _bannerDetails.setSeqencing(1);
        } else {
            Optional<BannerDetails> optional = bannerRepository.findById(bannerDetailsOperateDto.getId());
            if (!optional.isPresent()) {
                throw new RuntimeException("数据异常...");
            }
            _bannerDetails = optional.get();
        }
        _bannerDetails.setBannerTitle(bannerDetailsOperateDto.getBannerTitle());
        _bannerDetails.setImageUrl(bannerDetailsOperateDto.getImageUrl());
        _bannerDetails.setBannerOn(bannerDetailsOperateDto.getBannerOn());
        _bannerDetails.setBannerUrl(bannerDetailsOperateDto.getBannerUrl());
        if(bannerDetailsOperateDto.getBannerOn() == null) {
            _bannerDetails.setBannerOn(0);
        }
        bannerRepository.save(_bannerDetails);
    }

    public BannerDetails findbyid(String bannerId) {
        return bannerRepository.findByIdAndSeqencing(Long.valueOf(bannerId));
    }

    public void delete(ListDto list) {
        for (String i : list.getIdList()) {
            bannerRepository.fakedel(Long.valueOf(i));
        }
    }

}
