package cn.com.sailfish.linghang.service.admin;

import cn.com.sailfish.linghang.dao.web.response.PageResponse;
import cn.com.sailfish.linghang.domain.User;
import cn.com.sailfish.linghang.repository.UserRepository;
import io.micrometer.core.instrument.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.*;
import org.springframework.stereotype.Service;

import java.util.Optional;

@Service
public class RBACAdminService {

    @Autowired
    private UserRepository userRepository;

    public PageResponse<User> findAllByStatue(Integer page, Integer pageSize,String crux) {
        User user = new User();
        user.setIsDel(0);

        if (!StringUtils.isEmpty(crux)) {
            user.setCard(crux);
            Example<User> example = Example.of(user, ExampleMatcher.matching().withMatcher("card", ExampleMatcher.GenericPropertyMatchers.contains()));
            Pageable pageable = PageRequest.of(page - 1, pageSize);
            Page<User> users = userRepository.findAll(example, pageable);
            return userPageResponse(users);
        }
        Example<User> example = Example.of(user);
        Pageable pageable = PageRequest.of(page - 1, pageSize);
        Page<User> all = userRepository.findAll(example, pageable);
        return userPageResponse(all);
    }

    public synchronized PageResponse<User> userPageResponse(Page<User> newscourseIntroduce) {
        PageResponse pageResponse = new PageResponse();
        if (newscourseIntroduce != null) {
            pageResponse.setPageIndex(newscourseIntroduce.getPageable().getPageNumber() + 1);
            pageResponse.setPageSize(newscourseIntroduce.getPageable().getPageSize());
            pageResponse.setTotalCount(newscourseIntroduce.getTotalElements());
            pageResponse.setTotalPageCount(newscourseIntroduce.getTotalPages());
            pageResponse.setList(newscourseIntroduce.getContent());
        }
        return pageResponse;
    }

    public void ChangeRBAC(String id, String type) {
        Optional<User> byId = userRepository.findById(Long.valueOf(id));
        User user = byId.get();
        if (type.equals("0")) {
            if(user.getAuthorityTemplate() == null) {
                user.setAuthorityTemplate("0");
            } else {
                String authorityLinghang = user.getAuthorityTemplate();
                if (authorityLinghang.equals("0")) {
                    user.setAuthorityTemplate(null);
                }
                if (authorityLinghang.equals("1")) {
                    user.setAuthorityTemplate("0,1");
                }
                if (authorityLinghang.equals("0,1")) {
                    user.setAuthorityTemplate("1");
                }
            }
        }
        if (type.equals("1")) {
            if(user.getAuthorityTemplate() == null) {
                user.setAuthorityTemplate("1");
            } else{
                String authorityLinghang = user.getAuthorityTemplate();
                if (authorityLinghang.equals("0")) {
                    user.setAuthorityTemplate("0,1");
                }
                if (authorityLinghang.equals("1")) {
                    user.setAuthorityTemplate(null);
                }
                if (authorityLinghang.equals("0,1")) {
                    user.setAuthorityTemplate("0");
                }
            }
        }
        userRepository.save(user);
    }

    public void ChangeActivation(String id) {
        Optional<User> byId = userRepository.findById(Long.valueOf(id));
        User user = byId.get();
        if(user.getActivation()) {
            user.setActivation(false);
        }else {
            user.setActivation(true);
        }
        userRepository.save(user);
    }

    public String RABCfindbyid(String id) {
        Optional<User> byid = userRepository.findById(Long.valueOf(id));
        User user = byid.get();
        String authorityTemplate = user.getAuthorityTemplate();
        return authorityTemplate;
    }
}
