package cn.com.sailfish.linghang.service.portal;

import cn.com.sailfish.linghang.dao.web.response.PageResponse;
import cn.com.sailfish.linghang.domain.BannerDetails;
import cn.com.sailfish.linghang.repository.BannerRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.*;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class BannerManagePortalService {

    @Autowired
    private BannerRepository bannerRepository;


    public List<BannerDetails> findAll() {
        BannerDetails bannerDetails = new BannerDetails();
        bannerDetails.setIsDel(0);
        bannerDetails.setBannerOn(1);
        Example<BannerDetails> example = Example.of(bannerDetails, ExampleMatcher.matching());
        Sort sort = new Sort(Sort.Direction.DESC, "BannerOn")
                .and(new Sort(Sort.Direction.ASC, "seqencing"));
        return bannerRepository.findAll(example,sort);
    }


    public BannerDetails findById(String id) {
        return bannerRepository.findBannerDetailsById(Long.valueOf(id));
    }

    public void changeBannerOn(String id) {
        BannerDetails vrbannerDetail = bannerRepository.findBannerDetailsById(Long.valueOf(id));
        if (vrbannerDetail != null) {
            if (vrbannerDetail.getBannerOn() == 0) {
                vrbannerDetail.setBannerOn(1);
            } else {
                vrbannerDetail.setBannerOn(0);
            }
            bannerRepository.save(vrbannerDetail);
        }
    }

    /**
     * @param id
     * @description 前移方法
     */
    public void forward(long id) {
        BannerDetails bannerDetails = bannerRepository.findByIdAndSeqencing(id);
        if (bannerDetails != null) {
            bannerRepository.forward(id);
        }
    }

    /**
     * description 后移方法
     *
     * @param id
     * @return
     */
    public void backward(long id) {
        bannerRepository.backward(id);
    }

    public PageResponse<BannerDetails> pagebystatue(Integer page, Integer pageSize) {

        BannerDetails bannerDetails = new BannerDetails();

        bannerDetails.setIsDel(0);

        Example<BannerDetails> example = Example.of(bannerDetails, ExampleMatcher.matching());

        List<Sort.Order> orders = new ArrayList<>();
        orders.add(new Sort.Order(Sort.Direction.ASC, "seqencing"));
        orders.add(new Sort.Order(Sort.Direction.DESC, "gmtCreated"));

        Pageable pageable = PageRequest.of(page - 1, pageSize, new Sort(orders));
        Page<BannerDetails> vrDetailPage = bannerRepository.findAll(example, pageable);
        return BannerDetailsPageResponse(vrDetailPage);
    }

    public synchronized PageResponse<BannerDetails> BannerDetailsPageResponse(Page<BannerDetails> newscourseIntroduce) {
        PageResponse pageResponse = new PageResponse();
        if (newscourseIntroduce != null) {
            pageResponse.setPageIndex(newscourseIntroduce.getPageable().getPageNumber() + 1);
            pageResponse.setPageSize(newscourseIntroduce.getPageable().getPageSize());
            pageResponse.setTotalCount(newscourseIntroduce.getTotalElements());
            pageResponse.setTotalPageCount(newscourseIntroduce.getTotalPages());
            pageResponse.setList(newscourseIntroduce.getContent());
        }
        return pageResponse;
    }
}
