package cn.com.sailfish.linghang.service.portal;

import cn.com.sailfish.linghang.dao.web.response.PageResponse;
import cn.com.sailfish.linghang.domain.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class BannerPortalService {
    @Autowired
    private BannerManagePortalService bannerManagePortalService;
    @Autowired
    private CourseIntroducePortalService courseIntroducePortalService;
    @Autowired
    private NewsPaperPortalService newsPaperPortalService;
    @Autowired
    private TheModelPortalService theModelPortalService;
    @Autowired
    private VrPanoramPortalService vrPanoramPortalService;


    public Map<String, List<?>> bannershow() {
        Map<String, List<?>> hashmap = new HashMap<>();
        List<BannerDetails> bannerlist = bannerManagePortalService.findAll();
        List<CourseIntroduce> coureslist = courseIntroducePortalService.findAll();
        List<NewsPaper> newslist = newsPaperPortalService.findAll();
        List<ThdModel> thdist = theModelPortalService.findAll();
        List<VrDetails> vrDetailsList = vrPanoramPortalService.findAll();
        hashmap.put("bannerlist", bannerlist);
        hashmap.put("coureslist", coureslist);
        hashmap.put("newslist", newslist);
        hashmap.put("thdist", thdist);
        hashmap.put("vrDetailsList", vrDetailsList);

        return hashmap;
    }

    public Map<String, PageResponse<?>> findBycrux(String crux, String type, Integer page, Integer pageSize,String newstype) {
        Map<String, PageResponse<?>> hashMap = new HashMap<>();
        switch (type) {
            case "1":
                PageResponse<NewsPaper> newspaperlist = newsPaperPortalService.findAllByStatueAndId(page, pageSize, crux,newstype);
                hashMap.put("newspaperlist", newspaperlist);
                break;
            case "2":
                PageResponse<CourseIntroduce> newspaperlistndustry = courseIntroducePortalService.findAllByStatue(page, pageSize, crux);
                hashMap.put("courseIntroduceList", newspaperlistndustry);
                break;
            case "3":
                PageResponse<VrDetails> vrDetailsList = vrPanoramPortalService.pagebystatue(page, pageSize, crux);
                hashMap.put("vrDetailsList", vrDetailsList);
                break;
            case "4":
                PageResponse<ThdModel> courseIntroduceList = theModelPortalService.pagebystatue(page, pageSize, crux);
                hashMap.put("mhdModelList", courseIntroduceList);
                break;
        }
        return hashMap;
    }

}
