package cn.com.sailfish.linghang.service.portal;

import cn.com.sailfish.linghang.dao.web.response.PageResponse;
import cn.com.sailfish.linghang.domain.CourseIntroduce;
import cn.com.sailfish.linghang.repository.CourseIntroduceRepository;
import io.micrometer.core.instrument.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.*;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class CourseIntroducePortalService {

    @Autowired
    private CourseIntroduceRepository courseIntroduceRepository;


    public List<CourseIntroduce> findAll() {
        CourseIntroduce courseIntroduce = new CourseIntroduce();
        courseIntroduce.setIsDel(0);
        courseIntroduce.setReleaseStatue(1);
        Example<CourseIntroduce> example = Example.of(courseIntroduce, ExampleMatcher.matching());
        Sort sort = new Sort(Sort.Direction.DESC, "pushIndex")
                .and(new Sort(Sort.Direction.ASC, "seqencing"))
                .and(new Sort(Sort.Direction.DESC, "gmtCreated"));
        return courseIntroduceRepository.findAll(example,sort);
    }

    public PageResponse<CourseIntroduce>  findAllByStatue(Integer page, Integer pageSize, String crux) {

        CourseIntroduce courseIntroduce = new CourseIntroduce();
        courseIntroduce.setIsDel(0);
        courseIntroduce.setReleaseStatue(1);
        ExampleMatcher matcher;

        List<Sort.Order> orders=new ArrayList<>();
        orders.add( new Sort.Order(Sort.Direction. DESC, "secondTop"));
        orders.add( new Sort.Order(Sort.Direction. ASC, "seqencing"));
        orders.add( new Sort.Order(Sort.Direction. DESC, "gmtCreated"));

        if (!StringUtils.isEmpty(crux)) {
            Pageable pageable = PageRequest.of(page - 1, pageSize, new Sort(orders));
            Page<CourseIntroduce> Courseintroduce = courseIntroduceRepository.findpage(crux, pageable);
            return courseIntroducePageResponse(Courseintroduce);

        }
        Example<CourseIntroduce> example = Example.of(courseIntroduce);
        Pageable pageable = PageRequest.of(page - 1, pageSize,  new Sort(orders));
        Page<CourseIntroduce> Courseintroduce = courseIntroduceRepository.findAll(example,pageable);
        return courseIntroducePageResponse(Courseintroduce);
    }

    /**
     * @param id
     * @return
     * @description 根据有效状态查询ID；
     */
    public CourseIntroduce findbyid(String id) {
        CourseIntroduce courseIntroduce = courseIntroduceRepository.findCourseIntroducesById(Long.valueOf(id));
        return courseIntroduce;
    }

    public synchronized PageResponse<CourseIntroduce> courseIntroducePageResponse(Page<CourseIntroduce> newscourseIntroduce) {
        PageResponse<CourseIntroduce> pageResponse = new PageResponse();
        if (newscourseIntroduce != null) {
            pageResponse.setPageIndex(newscourseIntroduce.getPageable().getPageNumber() + 1);
            pageResponse.setPageSize(newscourseIntroduce.getPageable().getPageSize());
            pageResponse.setTotalCount(newscourseIntroduce.getTotalElements());
            pageResponse.setTotalPageCount(newscourseIntroduce.getTotalPages());
            pageResponse.setList(newscourseIntroduce.getContent());
        }
        return pageResponse;
    }
}
