package cn.com.sailfish.linghang.service.portal;

import cn.com.sailfish.linghang.dao.web.response.PageResponse;
import cn.com.sailfish.linghang.domain.SelectAllFromCruxView;
import cn.com.sailfish.linghang.repository.SelectAllFromCruxViewRepository;
import io.micrometer.core.instrument.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;


@Service
public class SearchPortalService {

    @Autowired
    private SelectAllFromCruxViewRepository selectAllFromCruxViewRepository;

    @Autowired
    private CourseIntroducePortalService courseIntroducePortalService;

    @Autowired
    private NewsPaperPortalService newsPaperPortalService;

    @Autowired
    private TheModelPortalService theModelPortalService;

    @Autowired
    private VrPanoramPortalService vrPanoramPortalService;

    public PageResponse<SelectAllFromCruxView> findViewByCrux(String crux, String type, Integer page, Integer pageSize) {
        Pageable pageable = PageRequest.of(page - 1, pageSize);
        if (type == null | type.equals("")) {
            if (!StringUtils.isEmpty(crux)) {
                Page<SelectAllFromCruxView> selectAllFromCruxPage = selectAllFromCruxViewRepository.findpage(crux, pageable);
                return selectAllFromCruxViewPageResponse(selectAllFromCruxPage);
            }

            Page<SelectAllFromCruxView> all = selectAllFromCruxViewRepository.findAll(pageable);
            return selectAllFromCruxViewPageResponse(all);
        } else {
            switch (type) {
                case "1": // 新闻资讯
                    if (!StringUtils.isEmpty(crux)) {
                        Page<SelectAllFromCruxView> selectAllFromCruxPage = selectAllFromCruxViewRepository.newspaperFindPageBycrux(crux, pageable);
                        return selectAllFromCruxViewPageResponse(selectAllFromCruxPage);
                    }

                    Page<SelectAllFromCruxView> selectAllPage = selectAllFromCruxViewRepository.newspaperFindPage(pageable);
                    return selectAllFromCruxViewPageResponse(selectAllPage);
                case "2": // 行业信息
                    if (!StringUtils.isEmpty(crux)) {
                        Page<SelectAllFromCruxView> selectAllFromCruxPage = selectAllFromCruxViewRepository.hangyeFindPageBycrux(crux, pageable);
                        return selectAllFromCruxViewPageResponse(selectAllFromCruxPage);
                    }

                    Page<SelectAllFromCruxView> selectAllFromCruxViews = selectAllFromCruxViewRepository.hangyeFindPage(pageable);
                    return selectAllFromCruxViewPageResponse(selectAllFromCruxViews);
                case "3": // VR全景图
                    if (!StringUtils.isEmpty(crux)) {
                        Page<SelectAllFromCruxView> selectAllFromCruxPage = selectAllFromCruxViewRepository.vrDetailsFindPageBycrux(crux, pageable);
                        return selectAllFromCruxViewPageResponse(selectAllFromCruxPage);
                    }

                    Page<SelectAllFromCruxView> selectAllFromVrdetilsViews = selectAllFromCruxViewRepository.vrDetailsFindPage(pageable);
                    return selectAllFromCruxViewPageResponse(selectAllFromVrdetilsViews);
                case "4": // 课程介绍
                    if (!StringUtils.isEmpty(crux)) {
                        Page<SelectAllFromCruxView> selectAllFromCruxPage = selectAllFromCruxViewRepository.courseFindPageBycrux(crux, pageable);
                        return selectAllFromCruxViewPageResponse(selectAllFromCruxPage);
                    }

                    Page<SelectAllFromCruxView> selectAllFromCourseViews = selectAllFromCruxViewRepository.courseFindPage(pageable);
                    return selectAllFromCruxViewPageResponse(selectAllFromCourseViews);
            }
        }
        return null;
    }

    public synchronized PageResponse<SelectAllFromCruxView> selectAllFromCruxViewPageResponse(Page<SelectAllFromCruxView> selectAllFromCruxViewPage) {
        PageResponse<SelectAllFromCruxView> pageResponse = new PageResponse<>();
        if (selectAllFromCruxViewPage != null) {
            pageResponse.setPageIndex(selectAllFromCruxViewPage.getPageable().getPageNumber() + 1);
            pageResponse.setPageSize(selectAllFromCruxViewPage.getPageable().getPageSize());
            pageResponse.setTotalCount(selectAllFromCruxViewPage.getTotalElements());
            pageResponse.setTotalPageCount(selectAllFromCruxViewPage.getTotalPages());
            pageResponse.setList(selectAllFromCruxViewPage.getContent());
        }

        return pageResponse;
    }
}
