package cn.com.sailfish.linghang.service.portal;

import cn.com.sailfish.linghang.dao.web.response.PageResponse;
import cn.com.sailfish.linghang.domain.CourseIntroduce;
import cn.com.sailfish.linghang.domain.ThdModel;
import cn.com.sailfish.linghang.repository.ThdModelRepository;
import io.micrometer.core.instrument.util.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.*;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class TheModelPortalService {

    @Autowired
    private ThdModelRepository thdModelRepository;

    private static final Logger log = LoggerFactory.getLogger(TheModelPortalService.class);

    public List<ThdModel> findAll(){
        ThdModel thdModel = new ThdModel();
        thdModel.setIsDel(0);
        thdModel.setReleaseStatue(1);
        Example<ThdModel> example = Example.of(thdModel, ExampleMatcher.matching());
        Sort sort = new Sort(Sort.Direction.DESC, "pushIndex")
                .and(new Sort(Sort.Direction.ASC, "seqencing"))
                .and(new Sort(Sort.Direction.DESC, "gmtCreated"));
        return thdModelRepository.findAll(example,sort);
    }


    /**
     * @description 分页
     * @param page
     * @param pageSize
     * @return
     */
    public PageResponse<ThdModel> pagebystatue(Integer page,Integer pageSize,String crux){

        ThdModel thdModel = new ThdModel();

        thdModel.setIsDel(0);
        thdModel.setReleaseStatue(1);
        ExampleMatcher matcher;

        List<Sort.Order> orders=new ArrayList<>();
        orders.add( new Sort.Order(Sort.Direction. DESC, "secondTop"));
        orders.add( new Sort.Order(Sort.Direction. ASC, "seqencing"));
        orders.add( new Sort.Order(Sort.Direction. DESC, "gmtCreated"));

        if (!StringUtils.isEmpty(crux)) {
            Pageable pageable = PageRequest.of(page - 1, pageSize, new Sort(orders));
            Page<ThdModel> thdModelPage = thdModelRepository.findpage(crux, pageable);
            return thdModelpageResponse(thdModelPage);
        }
        Example<ThdModel> example = Example.of(thdModel);
        Pageable pageable = PageRequest.of(page - 1, pageSize, new Sort(orders));
        Page<ThdModel> themodel = thdModelRepository.findAll(example,pageable);
        return thdModelpageResponse(themodel);
    }

    public synchronized PageResponse<ThdModel> thdModelpageResponse(Page<ThdModel> thdModelPaperPage){

        PageResponse<ThdModel> pageResponse=new PageResponse<>();
        if(thdModelPaperPage!=null){
            pageResponse.setPageIndex(thdModelPaperPage.getPageable().getPageNumber()+1);
            pageResponse.setPageSize(thdModelPaperPage.getPageable().getPageSize());
            pageResponse.setTotalCount(thdModelPaperPage.getTotalElements());
            pageResponse.setTotalPageCount(thdModelPaperPage.getTotalPages());
            pageResponse.setList(thdModelPaperPage.getContent());
        }

        return pageResponse;
    }
}
