package cn.com.sailfish.linghang.service.portal;

import cn.com.sailfish.linghang.dao.web.response.PageResponse;
import cn.com.sailfish.linghang.domain.VrDetails;
import cn.com.sailfish.linghang.repository.VrPanoramaRepository;
import io.micrometer.core.instrument.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.*;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Service
public class VrPanoramPortalService {

    @Autowired
    private VrPanoramaRepository vrPanoramaRepository;


    public List<VrDetails> findAll(){
        VrDetails vrDetails = new VrDetails();
        vrDetails.setIsDel(0);
        vrDetails.setReleaseStatue(1);
        Example<VrDetails> example = Example.of(vrDetails, ExampleMatcher.matching());
        Sort sort = new Sort(Sort.Direction.DESC, "pushIndex")
                .and(new Sort(Sort.Direction.ASC, "seqencing"))
                .and(new Sort(Sort.Direction.DESC, "gmtCreated"));
        return vrPanoramaRepository.findAll(example,sort);
    }

    public  PageResponse<VrDetails> pagebystatue(Integer page, Integer pageSize, String crux){
        VrDetails vrDetails = new VrDetails();
        vrDetails.setIsDel(0);
        vrDetails.setReleaseStatue(1);

        ExampleMatcher matcher;

        List<Sort.Order> orders=new ArrayList<>();
        orders.add( new Sort.Order(Sort.Direction. DESC, "secondTop"));
        orders.add( new Sort.Order(Sort.Direction. ASC, "seqencing"));
        orders.add( new Sort.Order(Sort.Direction. DESC, "gmtCreated"));

        if (!StringUtils.isEmpty(crux)) {
            Pageable pageable = PageRequest.of(page - 1, pageSize, new Sort(orders));
            Page<VrDetails> thdModelPage = vrPanoramaRepository.findpage(crux, pageable);
            return vrDetailsPageResponse(thdModelPage);

        }
        Example<VrDetails> example = Example.of(vrDetails);
        Pageable pageable = PageRequest.of(page - 1, pageSize,  new Sort(orders));
        Page<VrDetails> vrDetailPage = vrPanoramaRepository.findAll(example,pageable);
        return vrDetailsPageResponse(vrDetailPage);
    }

    public synchronized PageResponse<VrDetails> vrDetailsPageResponse(Page<VrDetails> VrDetailsPaperPage){

        PageResponse<VrDetails> pageResponse=new PageResponse<>();
        if(VrDetailsPaperPage!=null){
            pageResponse.setPageIndex(VrDetailsPaperPage.getPageable().getPageNumber()+1);
            pageResponse.setPageSize(VrDetailsPaperPage.getPageable().getPageSize());
            pageResponse.setTotalCount(VrDetailsPaperPage.getTotalElements());
            pageResponse.setTotalPageCount(VrDetailsPaperPage.getTotalPages());
            pageResponse.setList(VrDetailsPaperPage.getContent());
        }

        return pageResponse;
    }

    public VrDetails findbyid(String id) {
        Optional<VrDetails> vrDetails = vrPanoramaRepository.findById(Long.valueOf(id));
        return vrDetails.get();
    }
}
