package cn.com.sailfish.linghang.util;

import lombok.extern.slf4j.Slf4j;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.io.UnsupportedEncodingException;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;

/**
 * @author huangpeilin<plhuang @ sailfish.com.cn>
 * Create at: 2019-05-31 18:52:03
 * Description:
 */
@Slf4j
public class AESUtil {
    static private final String ENCODING = "UTF-8";
    static private final String TRANSFORMATION = "AES/CBC/PKCS5Padding";
    static private final String AES = "AES";

    public static String doEncryptedAES(String msj, String key) {
        String msjEncrypted = null;
        byte[] msjEncryptedbyte = null;
        byte[] keyByte = null;
        Cipher cp;
        SecretKeySpec sks = null;
        IvParameterSpec ips = null;
        try {
            msjEncryptedbyte = msj.getBytes(ENCODING);
            keyByte = getKeyBytes(key);
        } catch (NullPointerException e1) {
            e1.printStackTrace();
            return msjEncrypted;
        } catch (UnsupportedEncodingException e2) {
            e2.printStackTrace();
            return msjEncrypted;
        }

        sks = new SecretKeySpec(keyByte, AES);
        ips = new IvParameterSpec(keyByte);

        try {
            cp = Cipher.getInstance(TRANSFORMATION);
            cp.init(Cipher.ENCRYPT_MODE, sks, ips);
            msjEncryptedbyte = cp.doFinal(msjEncryptedbyte);
            msjEncrypted = Base64.getEncoder().encodeToString(msjEncryptedbyte);

        } catch (NoSuchAlgorithmException e1) {
            e1.printStackTrace();
        } catch (NoSuchPaddingException e2) {
            e2.printStackTrace();
        }  catch (InvalidKeyException e3) {
            e3.printStackTrace();
        }  catch (InvalidAlgorithmParameterException e4) {
            e4.printStackTrace();
        }  catch (IllegalBlockSizeException e5) {
            e5.printStackTrace();
        }  catch (BadPaddingException e6) {
            e6.printStackTrace();
        }
        return msjEncrypted;
    }

    public static String doDecryptedAES(String msjEncrypted, String key) {
        String msjDecrypted = null;
        byte[] msjEncryptedByte;
        byte[] keyByte;
        try {
            msjEncryptedByte = Base64.getDecoder().decode(msjEncrypted.getBytes("UTF8"));
            keyByte = getKeyBytes(key);
        } catch (NullPointerException e1) {
            e1.printStackTrace();
            return msjDecrypted;
        } catch (UnsupportedEncodingException e2) {
            e2.printStackTrace();
            return msjDecrypted;
        }
        SecretKeySpec sks = new SecretKeySpec(keyByte, AES);
        IvParameterSpec ips = new IvParameterSpec(keyByte);
        try {
            Cipher cp = Cipher.getInstance(TRANSFORMATION);
            cp.init(Cipher.DECRYPT_MODE, sks, ips);
            msjEncryptedByte = cp.doFinal(msjEncryptedByte);
            msjDecrypted = new String(msjEncryptedByte, ENCODING);
        } catch (NoSuchAlgorithmException e1) {
            e1.printStackTrace();
        } catch (NoSuchPaddingException e2) {
            e2.printStackTrace();
        }  catch (InvalidKeyException e3) {
            e3.printStackTrace();
        }  catch (InvalidAlgorithmParameterException e4) {
            e4.printStackTrace();
        }  catch (IllegalBlockSizeException e5) {
            e5.printStackTrace();
        }  catch (BadPaddingException e6) {
            e6.printStackTrace();
        } catch (UnsupportedEncodingException e7) {
            e7.printStackTrace();
        }
        return msjDecrypted;
    }

    private static byte[] getKeyBytes(String key) {
        byte[] keyBytes = new byte[16];
        try {
            byte[] parameterKeyBytes = key.getBytes(ENCODING);
            System.arraycopy(parameterKeyBytes, 0, keyBytes, 0, Math.min(parameterKeyBytes.length, keyBytes.length));
        } catch (UnsupportedEncodingException e) {
            log.error("[Error][AES][getKeyBytes][{}]: ", e.getMessage());
        }
        return keyBytes;
    }
}
