package cn.com.sailfish.linghang.util;

/**
 * Author: huangpeilin
 * Create at: 2019-05-08 15:05:30
 * Description:
 *
 * @author huangpeilin
 */
public class StringUtil {

    /**
     * byte装化为16进制数
     * @param src
     * @return
     */
    public static String bytesToHexString(byte[] src){
        StringBuilder stringBuilder = new StringBuilder("");
        if (src == null || src.length <= 0) {
            return null;
        }
        for (int i = 0; i < src.length; i++) {
            int v = src[i] & 0xFF;
            String hv = Integer.toHexString(v);
            if (hv.length() < 2) {
                stringBuilder.append(0);
            }
            stringBuilder.append(hv);
        }
        return stringBuilder.toString();
    }

    /**
     * 将字符串用特定的分隔符拆分成字符串数组
     * @param str
     * @param separator
     * @return
     */
    public static String[] split(String str, String separator){
        return str.split(separator);
    }

    /**
     * 将null装化为空的字符串
     * @param str
     * @return
     */
    public static String nullToEmpty(String str){
        if (str == null){
            str = "";
        }
        return str;
    }

    /**
     * 移除指定开头字符串和指定结尾字符串的字符串的开头和结尾
     * @param str
     * @param start 开头的字符串 为空不处理
     * @param end 结尾的字符串 为空不处理
     * @return
     */
    public static String removeAssignmentSymbol(String str, String start, String end){
        if (str != null && !"".equals(str)){
            if (start != null && !"".equals(start)){
                if (str.startsWith(start)){
                    int i = str.indexOf(start);
                    str = str.substring(0, i) + str.substring(i+1);
                }
            }
            if (end != null && !"".equals(end)){
                if (str.endsWith(end)){
                    int i = str.lastIndexOf(end);
                    str = str.substring(0, i);
                }
            }
        }
        return str;
    }

    /**
     * 判断字符串是否为空
     * @param str
     */
    public static boolean isEmpty(String str){
        if (str == null || "".equals(str.trim())){
            return true;
        }
        return false;
    }
}
